/*
  $Id: Structs.h,v 1.111 2010/10/13 19:23:47 crc_canada Exp $

  Structs.h: generated by VRMLC.pm. DO NOT MODIFY, MODIFY VRMLC.pm INSTEAD.

  Code here comes almost verbatim from VRMLC.pm

*/

/****************************************************************************
    This file is part of the FreeWRL/FreeX3D Distribution.

    Copyright 2009 CRC Canada. (http://www.crc.gc.ca)

    FreeWRL/FreeX3D is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    FreeWRL/FreeX3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with FreeWRL/FreeX3D.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************************/



#ifndef __FREEWRL_STRUCTS_H__
#define __FREEWRL_STRUCTS_H__


struct point_XYZ {GLDOUBLE x,y,z;};
struct orient_XYZA {GLDOUBLE x,y,z,a;};

struct X3D_Virt {
	void (*prep)(void *);
	void (*rend)(void *);
	void (*children)(void *);
	void (*fin)(void *);
	void (*rendray)(void *);
	void (*mkpolyrep)(void *);
	void (*proximity)(void *);
	void (*other)(void *);
	void (*collision)(void *);
	void (*compile)(void *, void *, void *, void *, void *);
};

/* a string is stored as a pointer, and a length of that mallocd pointer */
struct Uni_String {
	int len;
	char * strptr;
	int touched;
};

/* Internal representation of IndexedFaceSet, Text, Extrusion & ElevationGrid:
 * set of triangles.
 * done so that we get rid of concave polygons etc.
 */
struct X3D_PolyRep { /* Currently a bit wasteful, because copying */
	int irep_change;
	int ccw;	/* ccw field for single faced structures */
	int ntri; /* number of triangles */
	int streamed;	/* is this done the streaming pass? */
	int alloc_tri; /* number of allocated triangles */
	int *cindex;   /* triples (per triangle) */
	float *actualCoord; /* triples (per point) */
	int *colindex;   /* triples (per triangle) */
	float *color; /* triples or null */
	int *norindex;
	float *normal; /* triples or null */
        int *tcindex; /* triples or null */
        float *GeneratedTexCoords;	/* triples (per triangle) of texture coords if there is no texCoord node */
	int tcoordtype; /* type of texture coord node - is this a NODE_TextureCoordGenerator... */
	GLfloat minVals[3];		/* for collision and default texture coord generation */
	GLfloat maxVals[3];		/* for collision and default texture coord generation */
	GLfloat transparency;		/* what the transparency value was during compile, put in color array if RGBA colors */
	int isRGBAcolorNode;		/* color was originally an RGBA, DO NOT re-write if transparency changes */
	GLuint VBO_buffers[VBO_COUNT];		/* VBO indexen */
};

/* viewer dimentions (for collision detection) */
struct sNaviInfo {
        double width;
        double height;
        double step;
};

/* definitions to help scanning values in from a string */ 
#define SCANTONUMBER(value) while (isspace(*value) || (*value==',')) value++; 
#define SCANTOSTRING(value) while (isspace(*value) || (*value==',')) value++; 
#define OLDSCANTOSTRING(value) while ((*value==' ') || (*value==',')) value++; 
#define ISSTARTNUMBER(value) (isdigit(*value) \
		|| (*value == '+') || (*value == '-')) 
#define SCANPASTFLOATNUMBER(value) while (isdigit(*value) \
		|| (*value == '.') || \
		(*value == 'E') || (*value == 'e') || (*value == '+') || (*value == '-')) value++; 
#define SCANPASTINTNUMBER(value) if (isdigit(*value) || (*value == '-') || (*value == '+')) value++; \
		while (isdigit(*value) || \
		(*value == 'x') || (*value == 'X') ||\
		((*value >='a') && (*value <='f')) || \
		((*value >='A') && (*value <='F')) || \
		(*value == '-') || (*value == '+')) value++; 
/* Data type for index into ID-table. */
typedef int indexT;

#define NODE_Anchor	0
#define NODE_Appearance	1
#define NODE_Arc2D	2
#define NODE_ArcClose2D	3
#define NODE_AudioClip	4
#define NODE_AudioControl	5
#define NODE_Background	6
#define NODE_Billboard	7
#define NODE_BooleanFilter	8
#define NODE_BooleanSequencer	9
#define NODE_BooleanToggle	10
#define NODE_BooleanTrigger	11
#define NODE_Box	12
#define NODE_Circle2D	13
#define NODE_ClipPlane	14
#define NODE_Collision	15
#define NODE_Color	16
#define NODE_ColorInterpolator	17
#define NODE_ColorRGBA	18
#define NODE_ComposedCubeMapTexture	19
#define NODE_ComposedShader	20
#define NODE_Cone	21
#define NODE_Contour2D	22
#define NODE_ContourPolyLine2D	23
#define NODE_Coordinate	24
#define NODE_CoordinateInterpolator	25
#define NODE_CoordinateInterpolator2D	26
#define NODE_Cylinder	27
#define NODE_CylinderSensor	28
#define NODE_DISEntityManager	29
#define NODE_DISEntityTypeMapping	30
#define NODE_DirectionalLight	31
#define NODE_Disk2D	32
#define NODE_EaseInEaseOut	33
#define NODE_ElevationGrid	34
#define NODE_EspduTransform	35
#define NODE_Extrusion	36
#define NODE_FillProperties	37
#define NODE_FloatVertexAttribute	38
#define NODE_Fog	39
#define NODE_FogCoordinate	40
#define NODE_FontStyle	41
#define NODE_GeneratedCubeMapTexture	42
#define NODE_GeoCoordinate	43
#define NODE_GeoElevationGrid	44
#define NODE_GeoLOD	45
#define NODE_GeoLocation	46
#define NODE_GeoMetadata	47
#define NODE_GeoOrigin	48
#define NODE_GeoPositionInterpolator	49
#define NODE_GeoProximitySensor	50
#define NODE_GeoTouchSensor	51
#define NODE_GeoTransform	52
#define NODE_GeoViewpoint	53
#define NODE_Group	54
#define NODE_HAnimDisplacer	55
#define NODE_HAnimHumanoid	56
#define NODE_HAnimJoint	57
#define NODE_HAnimSegment	58
#define NODE_HAnimSite	59
#define NODE_ImageCubeMapTexture	60
#define NODE_ImageTexture	61
#define NODE_IndexedFaceSet	62
#define NODE_IndexedLineSet	63
#define NODE_IndexedTriangleFanSet	64
#define NODE_IndexedTriangleSet	65
#define NODE_IndexedTriangleStripSet	66
#define NODE_Inline	67
#define NODE_IntegerSequencer	68
#define NODE_IntegerTrigger	69
#define NODE_KeySensor	70
#define NODE_LOD	71
#define NODE_LineProperties	72
#define NODE_LineSet	73
#define NODE_LoadSensor	74
#define NODE_LocalFog	75
#define NODE_Material	76
#define NODE_Matrix3VertexAttribute	77
#define NODE_Matrix4VertexAttribute	78
#define NODE_MetadataDouble	79
#define NODE_MetadataFloat	80
#define NODE_MetadataInteger	81
#define NODE_MetadataMFBool	82
#define NODE_MetadataMFColor	83
#define NODE_MetadataMFColorRGBA	84
#define NODE_MetadataMFDouble	85
#define NODE_MetadataMFFloat	86
#define NODE_MetadataMFInt32	87
#define NODE_MetadataMFMatrix3d	88
#define NODE_MetadataMFMatrix3f	89
#define NODE_MetadataMFMatrix4d	90
#define NODE_MetadataMFMatrix4f	91
#define NODE_MetadataMFNode	92
#define NODE_MetadataMFRotation	93
#define NODE_MetadataMFString	94
#define NODE_MetadataMFTime	95
#define NODE_MetadataMFVec2d	96
#define NODE_MetadataMFVec2f	97
#define NODE_MetadataMFVec3d	98
#define NODE_MetadataMFVec3f	99
#define NODE_MetadataMFVec4d	100
#define NODE_MetadataMFVec4f	101
#define NODE_MetadataSFBool	102
#define NODE_MetadataSFColor	103
#define NODE_MetadataSFColorRGBA	104
#define NODE_MetadataSFDouble	105
#define NODE_MetadataSFFloat	106
#define NODE_MetadataSFImage	107
#define NODE_MetadataSFInt32	108
#define NODE_MetadataSFMatrix3d	109
#define NODE_MetadataSFMatrix3f	110
#define NODE_MetadataSFMatrix4d	111
#define NODE_MetadataSFMatrix4f	112
#define NODE_MetadataSFNode	113
#define NODE_MetadataSFRotation	114
#define NODE_MetadataSFString	115
#define NODE_MetadataSFTime	116
#define NODE_MetadataSFVec2d	117
#define NODE_MetadataSFVec2f	118
#define NODE_MetadataSFVec3d	119
#define NODE_MetadataSFVec3f	120
#define NODE_MetadataSFVec4d	121
#define NODE_MetadataSFVec4f	122
#define NODE_MetadataSet	123
#define NODE_MetadataString	124
#define NODE_MidiControl	125
#define NODE_MovieTexture	126
#define NODE_MultiTexture	127
#define NODE_MultiTextureCoordinate	128
#define NODE_MultiTextureTransform	129
#define NODE_NavigationInfo	130
#define NODE_Normal	131
#define NODE_NormalInterpolator	132
#define NODE_NurbsCurve	133
#define NODE_NurbsCurve2D	134
#define NODE_NurbsGroup	135
#define NODE_NurbsPositionInterpolator	136
#define NODE_NurbsSurface	137
#define NODE_NurbsTextureSurface	138
#define NODE_NurbsTrimmedSurface	139
#define NODE_OrientationInterpolator	140
#define NODE_OrthoViewpoint	141
#define NODE_PackagedShader	142
#define NODE_PickableGroup	143
#define NODE_PixelTexture	144
#define NODE_PlaneSensor	145
#define NODE_PointLight	146
#define NODE_PointPickSensor	147
#define NODE_PointSet	148
#define NODE_Polyline2D	149
#define NODE_Polypoint2D	150
#define NODE_PositionInterpolator	151
#define NODE_PositionInterpolator2D	152
#define NODE_ProgramShader	153
#define NODE_ProximitySensor	154
#define NODE_ReceiverPdu	155
#define NODE_Rectangle2D	156
#define NODE_ScalarInterpolator	157
#define NODE_Script	158
#define NODE_ShaderPart	159
#define NODE_ShaderProgram	160
#define NODE_Shape	161
#define NODE_SignalPdu	162
#define NODE_Sound	163
#define NODE_Sphere	164
#define NODE_SphereSensor	165
#define NODE_SplinePositionInterpolator	166
#define NODE_SplinePositionInterpolator2D	167
#define NODE_SplineScalarInterpolator	168
#define NODE_SpotLight	169
#define NODE_SquadOrientationInterpolator	170
#define NODE_StaticGroup	171
#define NODE_StringSensor	172
#define NODE_Switch	173
#define NODE_Text	174
#define NODE_TextureBackground	175
#define NODE_TextureCoordinate	176
#define NODE_TextureCoordinateGenerator	177
#define NODE_TextureProperties	178
#define NODE_TextureTransform	179
#define NODE_TimeSensor	180
#define NODE_TimeTrigger	181
#define NODE_TouchSensor	182
#define NODE_Transform	183
#define NODE_TransmitterPdu	184
#define NODE_TriangleFanSet	185
#define NODE_TriangleSet	186
#define NODE_TriangleSet2D	187
#define NODE_TriangleStripSet	188
#define NODE_TwoSidedMaterial	189
#define NODE_VRML1_AsciiText	190
#define NODE_VRML1_Cone	191
#define NODE_VRML1_Coordinate3	192
#define NODE_VRML1_Cube	193
#define NODE_VRML1_Cylinder	194
#define NODE_VRML1_DirectionalLight	195
#define NODE_VRML1_FontStyle	196
#define NODE_VRML1_IndexedFaceSet	197
#define NODE_VRML1_IndexedLineSet	198
#define NODE_VRML1_Info	199
#define NODE_VRML1_LOD	200
#define NODE_VRML1_Material	201
#define NODE_VRML1_MaterialBinding	202
#define NODE_VRML1_MatrixTransform	203
#define NODE_VRML1_Normal	204
#define NODE_VRML1_NormalBinding	205
#define NODE_VRML1_OrthographicCamera	206
#define NODE_VRML1_PerspectiveCamera	207
#define NODE_VRML1_PointLight	208
#define NODE_VRML1_PointSet	209
#define NODE_VRML1_Rotation	210
#define NODE_VRML1_Scale	211
#define NODE_VRML1_Separator	212
#define NODE_VRML1_ShapeHints	213
#define NODE_VRML1_Sphere	214
#define NODE_VRML1_SpotLight	215
#define NODE_VRML1_Switch	216
#define NODE_VRML1_Texture2	217
#define NODE_VRML1_Texture2Transform	218
#define NODE_VRML1_TextureCoordinate2	219
#define NODE_VRML1_Transform	220
#define NODE_VRML1_Translation	221
#define NODE_VRML1_WWWAnchor	222
#define NODE_VRML1_WWWInline	223
#define NODE_Viewpoint	224
#define NODE_ViewpointGroup	225
#define NODE_VisibilitySensor	226
#define NODE_WorldInfo	227


/* Table of built-in fieldIds */
extern const char *FIELDNAMES[];
extern const int FIELDNAMES_COUNT;
#define FIELDNAMES_wrapS	0
#define FIELDNAMES__sideVBO	1
#define FIELDNAMES__Value	2
#define FIELDNAMES_integerKey	3
#define FIELDNAMES___proxNode	4
#define FIELDNAMES_activate	5
#define FIELDNAMES_rootNode	6
#define FIELDNAMES_munitionSiteID	7
#define FIELDNAMES_modulationTypeMajor	8
#define FIELDNAMES_whichChoice	9
#define FIELDNAMES_load	10
#define FIELDNAMES_textureCoordIndex	11
#define FIELDNAMES_isLoaded	12
#define FIELDNAMES_rotation	13
#define FIELDNAMES_scaleFactor	14
#define FIELDNAMES_toggle	15
#define FIELDNAMES_set_articulationParameterValue7	16
#define FIELDNAMES_set_articulationParameterValue3	17
#define FIELDNAMES_title	18
#define FIELDNAMES_geoGridOrigin	19
#define FIELDNAMES_volumeFloatVal	20
#define FIELDNAMES___child4Node	21
#define FIELDNAMES_stripCount	22
#define FIELDNAMES_groundColor	23
#define FIELDNAMES_previous	24
#define FIELDNAMES_direction	25
#define FIELDNAMES_transmitterSiteID	26
#define FIELDNAMES_transmitterRadioID	27
#define FIELDNAMES_detonationResult	28
#define FIELDNAMES_maxPosition	29
#define FIELDNAMES_removeChildren	30
#define FIELDNAMES_skin	31
#define FIELDNAMES_speedFactor	32
#define FIELDNAMES_detonateTime	33
#define FIELDNAMES_entityKind	34
#define FIELDNAMES___shaderObj	35
#define FIELDNAMES_transmitterEntityID	36
#define FIELDNAMES_retainUserOffsets	37
#define FIELDNAMES_vertices	38
#define FIELDNAMES_filename	39
#define FIELDNAMES_autoButtonPress	40
#define FIELDNAMES___children	41
#define FIELDNAMES___do_scale	42
#define FIELDNAMES_left	43
#define FIELDNAMES___sidepoints	44
#define FIELDNAMES_inputTrue	45
#define FIELDNAMES___localFileName	46
#define FIELDNAMES_backAmbientIntensity	47
#define FIELDNAMES_exitTime	48
#define FIELDNAMES_joints	49
#define FIELDNAMES__oldhitNormal	50
#define FIELDNAMES_articulationParameterArray	51
#define FIELDNAMES_deletionAllowed	52
#define FIELDNAMES_translation	53
#define FIELDNAMES_address	54
#define FIELDNAMES___inRange	55
#define FIELDNAMES_articulationParameterValue6_changed	56
#define FIELDNAMES_child2Url	57
#define FIELDNAMES_limitOrientation	58
#define FIELDNAMES_skeleton	59
#define FIELDNAMES___cylinderTriangles	60
#define FIELDNAMES__oldhitPoint	61
#define FIELDNAMES_set_articulationParameterValue1	62
#define FIELDNAMES_type	63
#define FIELDNAMES_writeInterval	64
#define FIELDNAMES_entityID	65
#define FIELDNAMES_fired2	66
#define FIELDNAMES__bboxCenter	67
#define FIELDNAMES_creaseAngle	68
#define FIELDNAMES_triggerTime	69
#define FIELDNAMES_displacers	70
#define FIELDNAMES_isActive	71
#define FIELDNAMES___childloadstatus	72
#define FIELDNAMES_articulationParameterValue2_changed	73
#define FIELDNAMES_bboxCenter	74
#define FIELDNAMES_xDimension	75
#define FIELDNAMES_centerOfMass	76
#define FIELDNAMES_set_orientation	77
#define FIELDNAMES_set_position	78
#define FIELDNAMES_solid	79
#define FIELDNAMES_mode	80
#define FIELDNAMES___textureTableIndex	81
#define FIELDNAMES_map	82
#define FIELDNAMES_isRtpHeaderHeard	83
#define FIELDNAMES_on	84
#define FIELDNAMES_leftUrl	85
#define FIELDNAMES_warhead	86
#define FIELDNAMES___do_anything	87
#define FIELDNAMES_sortOrder	88
#define FIELDNAMES_isOver	89
#define FIELDNAMES_shininess	90
#define FIELDNAMES_texturePriority	91
#define FIELDNAMES_description	92
#define FIELDNAMES__wrapT	93
#define FIELDNAMES_top	94
#define FIELDNAMES_dropOffRate	95
#define FIELDNAMES_outerRadius	96
#define FIELDNAMES_fuse	97
#define FIELDNAMES_set_articulationParameterValue4	98
#define FIELDNAMES_touchTime	99
#define FIELDNAMES_family	100
#define FIELDNAMES_width	101
#define FIELDNAMES_skinNormal	102
#define FIELDNAMES_source	103
#define FIELDNAMES___lastParent	104
#define FIELDNAMES_front	105
#define FIELDNAMES_leftToRight	106
#define FIELDNAMES_linearVelocity	107
#define FIELDNAMES_entityDomain	108
#define FIELDNAMES___occludeCheckCount	109
#define FIELDNAMES_boundaryModeT	110
#define FIELDNAMES_summary	111
#define FIELDNAMES_transmitState	112
#define FIELDNAMES_info	113
#define FIELDNAMES_tdlType	114
#define FIELDNAMES__dlchange	115
#define FIELDNAMES_marking	116
#define FIELDNAMES_backSpecularColor	117
#define FIELDNAMES_ambientIntensity	118
#define FIELDNAMES_headlight	119
#define FIELDNAMES_highResolution	120
#define FIELDNAMES__bboxSize	121
#define FIELDNAMES_radioEntityTypeKind	122
#define FIELDNAMES_cycleInterval	123
#define FIELDNAMES_mass	124
#define FIELDNAMES_pickedGeometry	125
#define FIELDNAMES_pitch	126
#define FIELDNAMES_rotateYUp	127
#define FIELDNAMES_articulationParameterTypeArray	128
#define FIELDNAMES_bottomTexture	129
#define FIELDNAMES___oldJump	130
#define FIELDNAMES_sites	131
#define FIELDNAMES_encodingScheme	132
#define FIELDNAMES_fired1	133
#define FIELDNAMES__rotationAngle	134
#define FIELDNAMES___t2	135
#define FIELDNAMES_parameter	136
#define FIELDNAMES_borderWidth	137
#define FIELDNAMES_backTransparency	138
#define FIELDNAMES_generateMipMaps	139
#define FIELDNAMES_tessellation	140
#define FIELDNAMES_scale	141
#define FIELDNAMES_proxy	142
#define FIELDNAMES__coord	143
#define FIELDNAMES_translation_changed	144
#define FIELDNAMES_renderCulling	145
#define FIELDNAMES___numPoints	146
#define FIELDNAMES_ambientColor	147
#define FIELDNAMES__dcol	148
#define FIELDNAMES_maxFront	149
#define FIELDNAMES_rightTexture	150
#define FIELDNAMES_set_spine	151
#define FIELDNAMES___t1	152
#define FIELDNAMES_rotation_changed	153
#define FIELDNAMES___textureright	154
#define FIELDNAMES_skinCoordWeight	155
#define FIELDNAMES_plane	156
#define FIELDNAMES_radius	157
#define FIELDNAMES_articulationParameterValue7_changed	158
#define FIELDNAMES_controlPoint	159
#define FIELDNAMES_point	160
#define FIELDNAMES_inputSource	161
#define FIELDNAMES_radioEntityTypeNomenclatureVersion	162
#define FIELDNAMES_normal	163
#define FIELDNAMES___leftTexture	164
#define FIELDNAMES_articulationParameterChangeIndicatorArr	165
#define FIELDNAMES_firingRate	166
#define FIELDNAMES__oldrotation	167
#define FIELDNAMES_eventNumber	168
#define FIELDNAMES_loop	169
#define FIELDNAMES__wrapS	170
#define FIELDNAMES_actionKeyPress	171
#define FIELDNAMES_extra	172
#define FIELDNAMES_horizontal	173
#define FIELDNAMES__shin	174
#define FIELDNAMES_enabled	175
#define FIELDNAMES_pickedPoint	176
#define FIELDNAMES_fanCount	177
#define FIELDNAMES___child2Node	178
#define FIELDNAMES_triggerTrue	179
#define FIELDNAMES_shapeType	180
#define FIELDNAMES__parentResource	181
#define FIELDNAMES_articulationParameterCount	182
#define FIELDNAMES_avatarSize	183
#define FIELDNAMES_collide	184
#define FIELDNAMES_specularColor	185
#define FIELDNAMES_transitionTime	186
#define FIELDNAMES__oldintValue	187
#define FIELDNAMES_siteID	188
#define FIELDNAMES_color	189
#define FIELDNAMES_deviceMinVal	190
#define FIELDNAMES_axisOfRotation	191
#define FIELDNAMES_networkMode	192
#define FIELDNAMES_backEmissiveColor	193
#define FIELDNAMES_repeatT	194
#define FIELDNAMES__npv	195
#define FIELDNAMES___visible	196
#define FIELDNAMES___movedPosition	197
#define FIELDNAMES_topToBottom	198
#define FIELDNAMES_viewpoints	199
#define FIELDNAMES_FreeWRL__protoDef	200
#define FIELDNAMES_length	201
#define FIELDNAMES_index	202
#define FIELDNAMES___oldFieldOfView	203
#define FIELDNAMES_intensity	204
#define FIELDNAMES_navType	205
#define FIELDNAMES_update	206
#define FIELDNAMES_set_articulationParameterValue5	207
#define FIELDNAMES_heightAngle	208
#define FIELDNAMES__oldisActive	209
#define FIELDNAMES___loading	210
#define FIELDNAMES_next	211
#define FIELDNAMES_volumeInt32Val	212
#define FIELDNAMES___level	213
#define FIELDNAMES_isPaused	214
#define FIELDNAMES__oldpickedPoint	215
#define FIELDNAMES_value	216
#define FIELDNAMES_articulationParameterIdPartAttachedToAr	217
#define FIELDNAMES___child1Node	218
#define FIELDNAMES_multicastRelayHost	219
#define FIELDNAMES__color	220
#define FIELDNAMES___scriptObj	221
#define FIELDNAMES_keyRelease	222
#define FIELDNAMES___backTexture	223
#define FIELDNAMES_stopTime	224
#define FIELDNAMES__faceValue	225
#define FIELDNAMES_crossSection	226
#define FIELDNAMES_position	227
#define FIELDNAMES___solid	228
#define FIELDNAMES___do_scaleO	229
#define FIELDNAMES_xSpacing	230
#define FIELDNAMES_faceType	231
#define FIELDNAMES___transparency	232
#define FIELDNAMES_controller	233
#define FIELDNAMES_isDetonated	234
#define FIELDNAMES__butPr	235
#define FIELDNAMES_scaleOrientation	236
#define FIELDNAMES___ctflag	237
#define FIELDNAMES_inputFalse	238
#define FIELDNAMES_bottomUrl	239
#define FIELDNAMES_radioID	240
#define FIELDNAMES_hitPoint_changed	241
#define FIELDNAMES_boundaryModeS	242
#define FIELDNAMES__sortedChildren	243
#define FIELDNAMES_set_normalIndex	244
#define FIELDNAMES_knot	245
#define FIELDNAMES_articulationParameterValue4_changed	246
#define FIELDNAMES_justification	247
#define FIELDNAMES_set_articulationParameterValue6	248
#define FIELDNAMES_fogType	249
#define FIELDNAMES_spacing	250
#define FIELDNAMES_skyColor	251
#define FIELDNAMES__oldtranslation	252
#define FIELDNAMES_displacements	253
#define FIELDNAMES_isStandAlone	254
#define FIELDNAMES_panInt32Val	255
#define FIELDNAMES_topUrl	256
#define FIELDNAMES___colours	257
#define FIELDNAMES_geoSystem	258
#define FIELDNAMES___BGNumber	259
#define FIELDNAMES___shaderIDS	260
#define FIELDNAMES_addChildren	261
#define FIELDNAMES_detonationLocation	262
#define FIELDNAMES_attenuation	263
#define FIELDNAMES_fireMissionIndex	264
#define FIELDNAMES_articulationParameterValue3_changed	265
#define FIELDNAMES___oldLen	266
#define FIELDNAMES_endAngle	267
#define FIELDNAMES___oldKeyPtr	268
#define FIELDNAMES_displayed	269
#define FIELDNAMES_hitGeoCoord_changed	270
#define FIELDNAMES_focalDistance	271
#define FIELDNAMES_cycleTime	272
#define FIELDNAMES_deviceName	273
#define FIELDNAMES_boundaryModeR	274
#define FIELDNAMES___oldChildren	275
#define FIELDNAMES_intValue	276
#define FIELDNAMES_applied	277
#define FIELDNAMES_backTexture	278
#define FIELDNAMES_function	279
#define FIELDNAMES_setValue	280
#define FIELDNAMES_channel	281
#define FIELDNAMES_velocity	282
#define FIELDNAMES_isNetworkWriter	283
#define FIELDNAMES_hitTexCoord_changed	284
#define FIELDNAMES_alpha	285
#define FIELDNAMES_enteredText	286
#define FIELDNAMES__origNormalizedPoint	287
#define FIELDNAMES_repeatS	288
#define FIELDNAMES___do_trans	289
#define FIELDNAMES__origPoint	290
#define FIELDNAMES_backDiffuseColor	291
#define FIELDNAMES_bboxSize	292
#define FIELDNAMES_country	293
#define FIELDNAMES_visibilityRange	294
#define FIELDNAMES_textBounds	295
#define FIELDNAMES_munitionStartPoint	296
#define FIELDNAMES_skinCoordIndex	297
#define FIELDNAMES__coordIndex	298
#define FIELDNAMES_priority	299
#define FIELDNAMES_linetype	300
#define FIELDNAMES__oldtrackPoint	301
#define FIELDNAMES_receiverState	302
#define FIELDNAMES_addedEntities	303
#define FIELDNAMES_eventEntityID	304
#define FIELDNAMES_spatialize	305
#define FIELDNAMES_articulationParameterValue5_changed	306
#define FIELDNAMES_normalizeVelocity	307
#define FIELDNAMES___do_center	308
#define FIELDNAMES_geoOrigin	309
#define FIELDNAMES_metadata	310
#define FIELDNAMES_geoCoords	311
#define FIELDNAMES_relativeAntennaLocation	312
#define FIELDNAMES_location	313
#define FIELDNAMES_colorPerVertex	314
#define FIELDNAMES_origin	315
#define FIELDNAMES_jump	316
#define FIELDNAMES_directOutput	317
#define FIELDNAMES_port	318
#define FIELDNAMES___oldgeoCoords	319
#define FIELDNAMES_timeOut	320
#define FIELDNAMES_hitNormal_changed	321
#define FIELDNAMES_skyAngle	322
#define FIELDNAMES_useIntValue	323
#define FIELDNAMES_closureType	324
#define FIELDNAMES___finishedloading	325
#define FIELDNAMES_enterTime	326
#define FIELDNAMES___rooturlloadstatus	327
#define FIELDNAMES_center	328
#define FIELDNAMES_munitionEntityID	329
#define FIELDNAMES_altKey	330
#define FIELDNAMES_spine	331
#define FIELDNAMES_floatValue	332
#define FIELDNAMES_offset	333
#define FIELDNAMES___StartLoadTime	334
#define FIELDNAMES_cryptoSystem	335
#define FIELDNAMES___points	336
#define FIELDNAMES_cryptoKeyID	337
#define FIELDNAMES_anisotropicDegree	338
#define FIELDNAMES_parts	339
#define FIELDNAMES_keyVelocity	340
#define FIELDNAMES_collisionType	341
#define FIELDNAMES___simpleDisk	342
#define FIELDNAMES_normalPerVertex	343
#define FIELDNAMES_topTexture	344
#define FIELDNAMES_position_changed	345
#define FIELDNAMES__initialized	346
#define FIELDNAMES___hit	347
#define FIELDNAMES_set_articulationParameterValue0	348
#define FIELDNAMES_power	349
#define FIELDNAMES_category	350
#define FIELDNAMES_maxBack	351
#define FIELDNAMES_vector	352
#define FIELDNAMES_sampleRate	353
#define FIELDNAMES_modifiedFraction_changed	354
#define FIELDNAMES_firingRange	355
#define FIELDNAMES__bus	356
#define FIELDNAMES_geoCoord_changed	357
#define FIELDNAMES_controllerType	358
#define FIELDNAMES_set_index	359
#define FIELDNAMES_stiffness	360
#define FIELDNAMES___segCount	361
#define FIELDNAMES_samples	362
#define FIELDNAMES_detonationRelativeLocation	363
#define FIELDNAMES_minificationFilter	364
#define FIELDNAMES_attrib	365
#define FIELDNAMES_radioEntityTypeCountry	366
#define FIELDNAMES_child4Url	367
#define FIELDNAMES_rightUrl	368
#define FIELDNAMES_time	369
#define FIELDNAMES_deadReckoning	370
#define FIELDNAMES_fraction_changed	371
#define FIELDNAMES_segments	372
#define FIELDNAMES_texture	373
#define FIELDNAMES_programs	374
#define FIELDNAMES_speed	375
#define FIELDNAMES_objectType	376
#define FIELDNAMES_fillProperties	377
#define FIELDNAMES___VBO	378
#define FIELDNAMES_maxAngle	379
#define FIELDNAMES_controllerPresent	380
#define FIELDNAMES___movedValue	381
#define FIELDNAMES_modulationTypeSpreadSpectrum	382
#define FIELDNAMES_version	383
#define FIELDNAMES___loadResource	384
#define FIELDNAMES_image	385
#define FIELDNAMES___cylinderVBO	386
#define FIELDNAMES___botpoints	387
#define FIELDNAMES_receivedPower	388
#define FIELDNAMES_set_crossSection	389
#define FIELDNAMES___subTextures	390
#define FIELDNAMES_levelChanged	391
#define FIELDNAMES_colorIndex	392
#define FIELDNAMES_duration_changed	393
#define FIELDNAMES_order	394
#define FIELDNAMES_geometry	395
#define FIELDNAMES_multicastRelayPort	396
#define FIELDNAMES_textureProperties	397
#define FIELDNAMES_watchList	398
#define FIELDNAMES__channel	399
#define FIELDNAMES_lineProperties	400
#define FIELDNAMES__oldpickTarget	401
#define FIELDNAMES__controller	402
#define FIELDNAMES_data	403
#define FIELDNAMES_centerOfRotation	404
#define FIELDNAMES__scol	405
#define FIELDNAMES_minBack	406
#define FIELDNAMES___vertIndx	407
#define FIELDNAMES_backShininess	408
#define FIELDNAMES___movedCoords	409
#define FIELDNAMES___isX3D	410
#define FIELDNAMES_closed	411
#define FIELDNAMES_applicationID	412
#define FIELDNAMES_eventApplicationID	413
#define FIELDNAMES___vertArr	414
#define FIELDNAMES___coneTriangles	415
#define FIELDNAMES_trackPoint_changed	416
#define FIELDNAMES_global	417
#define FIELDNAMES_vTessellation	418
#define FIELDNAMES_back	419
#define FIELDNAMES_tickTime	420
#define FIELDNAMES_minVal	421
#define FIELDNAMES_articulationParameterValue0_changed	422
#define FIELDNAMES___rightTexture	423
#define FIELDNAMES___compiledmode	424
#define FIELDNAMES_pressTime	425
#define FIELDNAMES_geoCenter	426
#define FIELDNAMES_emissiveColor	427
#define FIELDNAMES_antennaPatternLength	428
#define FIELDNAMES_filled	429
#define FIELDNAMES_groundAngle	430
#define FIELDNAMES_mapping	431
#define FIELDNAMES_isValid	432
#define FIELDNAMES_string	433
#define FIELDNAMES_children	434
#define FIELDNAMES_isBound	435
#define FIELDNAMES_triggerValue	436
#define FIELDNAMES___compiledpoint	437
#define FIELDNAMES___bottomTexture	438
#define FIELDNAMES_controlKey	439
#define FIELDNAMES_textureCompression	440
#define FIELDNAMES_frontTexture	441
#define FIELDNAMES_entityCategory	442
#define FIELDNAMES_centerOfRotation_changed	443
#define FIELDNAMES_diskAngle	444
#define FIELDNAMES___Samples	445
#define FIELDNAMES_transmitFrequencyBandwidth	446
#define FIELDNAMES___do_rotation	447
#define FIELDNAMES_dataLength	448
#define FIELDNAMES_radioEntityTypeCategory	449
#define FIELDNAMES_set_fraction	450
#define FIELDNAMES_subcategory	451
#define FIELDNAMES_transitionComplete	452
#define FIELDNAMES_specific	453
#define FIELDNAMES___inittime	454
#define FIELDNAMES_backUrl	455
#define FIELDNAMES_set_sortOrder	456
#define FIELDNAMES_size	457
#define FIELDNAMES_maxExtent	458
#define FIELDNAMES_domain	459
#define FIELDNAMES_kind	460
#define FIELDNAMES_orientation_changed	461
#define FIELDNAMES___regenSubTextures	462
#define FIELDNAMES_readInterval	463
#define FIELDNAMES___child3Node	464
#define FIELDNAMES_buttonPress	465
#define FIELDNAMES_materialIndex	466
#define FIELDNAMES_style	467
#define FIELDNAMES_radioEntityTypeDomain	468
#define FIELDNAMES_bottom	469
#define FIELDNAMES_hatchColor	470
#define FIELDNAMES_justify	471
#define FIELDNAMES_removedEntities	472
#define FIELDNAMES_modulationTypeSystem	473
#define FIELDNAMES_side	474
#define FIELDNAMES_frontUrl	475
#define FIELDNAMES_dimension	476
#define FIELDNAMES_modulationTypeDetail	477
#define FIELDNAMES__solid	478
#define FIELDNAMES_separateBackColor	479
#define FIELDNAMES___rootUrl	480
#define FIELDNAMES_maxVal	481
#define FIELDNAMES_bindTime	482
#define FIELDNAMES_depth	483
#define FIELDNAMES_set_boolean	484
#define FIELDNAMES_fieldOfView	485
#define FIELDNAMES___oldHeadlight	486
#define FIELDNAMES_borderColor	487
#define FIELDNAMES_set_height	488
#define FIELDNAMES_child1Url	489
#define FIELDNAMES_endCap	490
#define FIELDNAMES_set_colorIndex	491
#define FIELDNAMES_reference	492
#define FIELDNAMES_uTessellation	493
#define FIELDNAMES___normals	494
#define FIELDNAMES_set_triggerTime	495
#define FIELDNAMES__oldhitTexCoord	496
#define FIELDNAMES__oldpickedGeometry	497
#define FIELDNAMES_value_changed	498
#define FIELDNAMES___oldKeyValuePtr	499
#define FIELDNAMES_keyValue	500
#define FIELDNAMES_bottomRadius	501
#define FIELDNAMES_mustEvaluate	502
#define FIELDNAMES_diffuseColor	503
#define FIELDNAMES_tessellationScale	504
#define FIELDNAMES_startIndex	505
#define FIELDNAMES__vertValue	506
#define FIELDNAMES_inputNegate	507
#define FIELDNAMES_keyWeight	508
#define FIELDNAMES_entitySpecific	509
#define FIELDNAMES_set_articulationParameterValue2	510
#define FIELDNAMES_key	511
#define FIELDNAMES__typeValue	512
#define FIELDNAMES__ecol	513
#define FIELDNAMES_ulimit	514
#define FIELDNAMES___quadcount	515
#define FIELDNAMES_skinCoord	516
#define FIELDNAMES_yScale	517
#define FIELDNAMES___oldEnabled	518
#define FIELDNAMES___movedOrientation	519
#define FIELDNAMES_name	520
#define FIELDNAMES_texCoord	521
#define FIELDNAMES__ccw	522
#define FIELDNAMES_pickable	523
#define FIELDNAMES___coneVBO	524
#define FIELDNAMES_lineBounds	525
#define FIELDNAMES_hatched	526
#define FIELDNAMES_easeInEaseOut	527
#define FIELDNAMES__creaseAngle	528
#define FIELDNAMES_level_changed	529
#define FIELDNAMES___texCoords	530
#define FIELDNAMES_geovalue_changed	531
#define FIELDNAMES__texCoord	532
#define FIELDNAMES_texCoordIndex	533
#define FIELDNAMES_beginCap	534
#define FIELDNAMES_linearAcceleration	535
#define FIELDNAMES_transparency	536
#define FIELDNAMES___vertexCount	537
#define FIELDNAMES_intersectionType	538
#define FIELDNAMES_set_bind	539
#define FIELDNAMES_textureTransform	540
#define FIELDNAMES___sourceNumber	541
#define FIELDNAMES_progress	542
#define FIELDNAMES_lengthOfModulationParameters	543
#define FIELDNAMES_height	544
#define FIELDNAMES_right	545
#define FIELDNAMES__deviceNameIndex	546
#define FIELDNAMES_pickingGeometry	547
#define FIELDNAMES_panFloatVal	548
#define FIELDNAMES_entityCountry	549
#define FIELDNAMES___localOrient	550
#define FIELDNAMES_isNetworkReader	551
#define FIELDNAMES_antennaPatternType	552
#define FIELDNAMES_startAngle	553
#define FIELDNAMES_minAngle	554
#define FIELDNAMES_weight	555
#define FIELDNAMES_visibilityLimit	556
#define FIELDNAMES_munitionApplicationID	557
#define FIELDNAMES_firedTime	558
#define FIELDNAMES__vel	559
#define FIELDNAMES__sentVel	560
#define FIELDNAMES_forceID	561
#define FIELDNAMES_articulationParameterDesignatorArray	562
#define FIELDNAMES_deltaInt32Val	563
#define FIELDNAMES___oldSize	564
#define FIELDNAMES__radius	565
#define FIELDNAMES_collideTime	566
#define FIELDNAMES___loadstatus	567
#define FIELDNAMES_magnificationFilter	568
#define FIELDNAMES_numComponents	569
#define FIELDNAMES_fogCoord	570
#define FIELDNAMES_munitionEndPoint	571
#define FIELDNAMES___oldGeoCenter	572
#define FIELDNAMES_choice	573
#define FIELDNAMES_hatchStyle	574
#define FIELDNAMES___params	575
#define FIELDNAMES_cutOffAngle	576
#define FIELDNAMES_minPosition	577
#define FIELDNAMES_linewidthScaleFactor	578
#define FIELDNAMES_deltaFloatVal	579
#define FIELDNAMES___geoSystem	580
#define FIELDNAMES_finalText	581
#define FIELDNAMES_rootUrl	582
#define FIELDNAMES_FreeWRL_PROTOInterfaceNodes	583
#define FIELDNAMES_entityExtra	584
#define FIELDNAMES_url	585
#define FIELDNAMES_coord	586
#define FIELDNAMES_startTime	587
#define FIELDNAMES___frontTexture	588
#define FIELDNAMES___topTexture	589
#define FIELDNAMES_minFront	590
#define FIELDNAMES_ccw	591
#define FIELDNAMES_valueChanged	592
#define FIELDNAMES__controllerIndex	593
#define FIELDNAMES_level	594
#define FIELDNAMES_vertexCount	595
#define FIELDNAMES_transitionType	596
#define FIELDNAMES___rendersub	597
#define FIELDNAMES_llimit	598
#define FIELDNAMES_range	599
#define FIELDNAMES_keyPress	600
#define FIELDNAMES_resumeTime	601
#define FIELDNAMES_antennaLocation	602
#define FIELDNAMES_timestamp	603
#define FIELDNAMES_vertexOrdering	604
#define FIELDNAMES_forceTransitions	605
#define FIELDNAMES_radioEntityTypeNomenclature	606
#define FIELDNAMES_shaders	607
#define FIELDNAMES_language	608
#define FIELDNAMES_VRML1children	609
#define FIELDNAMES__cpv	610
#define FIELDNAMES_shiftKey	611
#define FIELDNAMES_leftTexture	612
#define FIELDNAMES_lineSegments	613
#define FIELDNAMES_momentsOfInertia	614
#define FIELDNAMES_set_intersectionType	615
#define FIELDNAMES_coordIndex	616
#define FIELDNAMES_material	617
#define FIELDNAMES__selected	618
#define FIELDNAMES_set_scale	619
#define FIELDNAMES_transmitterApplicationID	620
#define FIELDNAMES_loadTime	621
#define FIELDNAMES__convex	622
#define FIELDNAMES_frequency	623
#define FIELDNAMES_actionKeyRelease	624
#define FIELDNAMES_articulationParameterValue1_changed	625
#define FIELDNAMES_isSelected	626
#define FIELDNAMES___oldMFString	627
#define FIELDNAMES_pressLength	628
#define FIELDNAMES_deviceMaxVal	629
#define FIELDNAMES_rtpHeaderExpected	630
#define FIELDNAMES_child3Url	631
#define FIELDNAMES_pauseTime	632
#define FIELDNAMES_isCollided	633
#define FIELDNAMES__ILS	634
#define FIELDNAMES_normalIndex	635
#define FIELDNAMES_beamWidth	636
#define FIELDNAMES_pickTarget	637
#define FIELDNAMES_zSpacing	638
#define FIELDNAMES_whichGeometry	639
#define FIELDNAMES___oldSFString	640
#define FIELDNAMES_eventSiteID	641
#define FIELDNAMES_innerRadius	642
#define FIELDNAMES_fontStyle	643
#define FIELDNAMES_convex	644
#define FIELDNAMES_orientation	645
#define FIELDNAMES_set_texCoordIndex	646
#define FIELDNAMES_whichChild	647
#define FIELDNAMES_appearance	648
#define FIELDNAMES_autoOffset	649
#define FIELDNAMES_wrapT	650
#define FIELDNAMES_zDimension	651
#define FIELDNAMES_maxDelta	652
#define FIELDNAMES__intControllerType	653
#define FIELDNAMES__normal	654
#define FIELDNAMES_entitySubCategory	655
#define FIELDNAMES_set_coordIndex	656
#define FIELDNAMES_munitionQuantity	657
#define FIELDNAMES_elapsedTime	658
#define FIELDNAMES_numPoints	659
#define FIELDNAMES___vertices	660
#define FIELDNAMES___initialized	661
#define FIELDNAMES__amb	662

const char *stringFieldType(int st);

/* Table of built-in fieldIds */
extern const char *EVENT_OUT[];
extern const int EVENT_OUT_COUNT;
#define EVENT_OUT_isStandAlone	0
#define EVENT_OUT_inputNegate	1
#define EVENT_OUT_panInt32Val	2
#define EVENT_OUT_isValid	3
#define EVENT_OUT_position_changed	4
#define EVENT_OUT_deltaFloatVal	5
#define EVENT_OUT_finalText	6
#define EVENT_OUT_isBound	7
#define EVENT_OUT_triggerValue	8
#define EVENT_OUT_isRtpHeaderHeard	9
#define EVENT_OUT_controlKey	10
#define EVENT_OUT_actionKeyPress	11
#define EVENT_OUT_centerOfRotation_changed	12
#define EVENT_OUT_isLoaded	13
#define EVENT_OUT_articulationParameterValue3_changed	14
#define EVENT_OUT_modifiedFraction_changed	15
#define EVENT_OUT_isOver	16
#define EVENT_OUT_hitGeoCoord_changed	17
#define EVENT_OUT_pickedPoint	18
#define EVENT_OUT_geoCoord_changed	19
#define EVENT_OUT_cycleTime	20
#define EVENT_OUT_valueChanged	21
#define EVENT_OUT_transitionComplete	22
#define EVENT_OUT_toggle	23
#define EVENT_OUT_lineBounds	24
#define EVENT_OUT_triggerTrue	25
#define EVENT_OUT_touchTime	26
#define EVENT_OUT_volumeFloatVal	27
#define EVENT_OUT_time	28
#define EVENT_OUT_keyPress	29
#define EVENT_OUT_fraction_changed	30
#define EVENT_OUT_level_changed	31
#define EVENT_OUT_isNetworkWriter	32
#define EVENT_OUT_hitTexCoord_changed	33
#define EVENT_OUT_orientation_changed	34
#define EVENT_OUT_timestamp	35
#define EVENT_OUT_enteredText	36
#define EVENT_OUT_geovalue_changed	37
#define EVENT_OUT_detonateTime	38
#define EVENT_OUT_progress	39
#define EVENT_OUT_shiftKey	40
#define EVENT_OUT_textBounds	41
#define EVENT_OUT_removedEntities	42
#define EVENT_OUT_panFloatVal	43
#define EVENT_OUT_inputTrue	44
#define EVENT_OUT_isNetworkReader	45
#define EVENT_OUT_loadTime	46
#define EVENT_OUT_volumeInt32Val	47
#define EVENT_OUT_addedEntities	48
#define EVENT_OUT_levelChanged	49
#define EVENT_OUT_actionKeyRelease	50
#define EVENT_OUT_isSelected	51
#define EVENT_OUT_articulationParameterValue1_changed	52
#define EVENT_OUT_exitTime	53
#define EVENT_OUT_duration_changed	54
#define EVENT_OUT_isPaused	55
#define EVENT_OUT_pickedGeometry	56
#define EVENT_OUT_isCollided	57
#define EVENT_OUT_articulationParameterValue5_changed	58
#define EVENT_OUT_firedTime	59
#define EVENT_OUT_articulationParameterValue6_changed	60
#define EVENT_OUT_origin	61
#define EVENT_OUT_bindTime	62
#define EVENT_OUT_keyRelease	63
#define EVENT_OUT_hitNormal_changed	64
#define EVENT_OUT_deltaInt32Val	65
#define EVENT_OUT_translation_changed	66
#define EVENT_OUT_collideTime	67
#define EVENT_OUT_enterTime	68
#define EVENT_OUT_isDetonated	69
#define EVENT_OUT_altKey	70
#define EVENT_OUT_rotation_changed	71
#define EVENT_OUT_triggerTime	72
#define EVENT_OUT_inputFalse	73
#define EVENT_OUT_value_changed	74
#define EVENT_OUT_trackPoint_changed	75
#define EVENT_OUT_isActive	76
#define EVENT_OUT_hitPoint_changed	77
#define EVENT_OUT_articulationParameterValue7_changed	78
#define EVENT_OUT_elapsedTime	79
#define EVENT_OUT_articulationParameterValue0_changed	80
#define EVENT_OUT_articulationParameterValue2_changed	81
#define EVENT_OUT_articulationParameterValue4_changed	82


/* Table of built-in fieldIds */
extern const char *EVENT_IN[];
extern const int EVENT_IN_COUNT;
#define EVENT_IN_set_position	0
#define EVENT_IN_set_articulationParameterValue5	1
#define EVENT_IN_next	2
#define EVENT_IN_set_scale	3
#define EVENT_IN_set_articulationParameterValue2	4
#define EVENT_IN_activate	5
#define EVENT_IN_addChildren	6
#define EVENT_IN_set_crossSection	7
#define EVENT_IN_set_articulationParameterValue0	8
#define EVENT_IN_set_index	9
#define EVENT_IN_set_articulationParameterValue1	10
#define EVENT_IN_set_fraction	11
#define EVENT_IN_set_boolean	12
#define EVENT_IN_set_articulationParameterValue7	13
#define EVENT_IN_set_articulationParameterValue3	14
#define EVENT_IN_set_articulationParameterValue4	15
#define EVENT_IN_set_texCoordIndex	16
#define EVENT_IN_setValue	17
#define EVENT_IN_set_height	18
#define EVENT_IN_set_sortOrder	19
#define EVENT_IN_previous	20
#define EVENT_IN_set_colorIndex	21
#define EVENT_IN_set_spine	22
#define EVENT_IN_set_triggerTime	23
#define EVENT_IN_removeChildren	24
#define EVENT_IN_set_bind	25
#define EVENT_IN_set_coordIndex	26
#define EVENT_IN_tickTime	27
#define EVENT_IN_set_normalIndex	28
#define EVENT_IN_set_articulationParameterValue6	29
#define EVENT_IN_coordIndex	30
#define EVENT_IN_set_intersectionType	31
#define EVENT_IN_set_orientation	32


/* Table of built-in fieldIds */
extern const char *EXPOSED_FIELD[];
extern const int EXPOSED_FIELD_COUNT;
#define EXPOSED_FIELD_wrapS	0
#define EXPOSED_FIELD_topTexture	1
#define EXPOSED_FIELD_integerKey	2
#define EXPOSED_FIELD_power	3
#define EXPOSED_FIELD_munitionSiteID	4
#define EXPOSED_FIELD_modulationTypeMajor	5
#define EXPOSED_FIELD_whichChoice	6
#define EXPOSED_FIELD_textureCoordIndex	7
#define EXPOSED_FIELD_vector	8
#define EXPOSED_FIELD_maxBack	9
#define EXPOSED_FIELD_sampleRate	10
#define EXPOSED_FIELD_rotation	11
#define EXPOSED_FIELD_firingRange	12
#define EXPOSED_FIELD_scaleFactor	13
#define EXPOSED_FIELD_controllerType	14
#define EXPOSED_FIELD_stiffness	15
#define EXPOSED_FIELD_samples	16
#define EXPOSED_FIELD_detonationRelativeLocation	17
#define EXPOSED_FIELD_minificationFilter	18
#define EXPOSED_FIELD_attrib	19
#define EXPOSED_FIELD_radioEntityTypeCountry	20
#define EXPOSED_FIELD_rightUrl	21
#define EXPOSED_FIELD_deadReckoning	22
#define EXPOSED_FIELD_segments	23
#define EXPOSED_FIELD_texture	24
#define EXPOSED_FIELD_groundColor	25
#define EXPOSED_FIELD_direction	26
#define EXPOSED_FIELD_transmitterSiteID	27
#define EXPOSED_FIELD_transmitterRadioID	28
#define EXPOSED_FIELD_detonationResult	29
#define EXPOSED_FIELD_programs	30
#define EXPOSED_FIELD_maxPosition	31
#define EXPOSED_FIELD_objectType	32
#define EXPOSED_FIELD_speed	33
#define EXPOSED_FIELD_fillProperties	34
#define EXPOSED_FIELD_controllerPresent	35
#define EXPOSED_FIELD_skin	36
#define EXPOSED_FIELD_maxAngle	37
#define EXPOSED_FIELD_modulationTypeSpreadSpectrum	38
#define EXPOSED_FIELD_version	39
#define EXPOSED_FIELD_entityKind	40
#define EXPOSED_FIELD_transmitterEntityID	41
#define EXPOSED_FIELD_retainUserOffsets	42
#define EXPOSED_FIELD_image	43
#define EXPOSED_FIELD_vertices	44
#define EXPOSED_FIELD_filename	45
#define EXPOSED_FIELD_autoButtonPress	46
#define EXPOSED_FIELD_left	47
#define EXPOSED_FIELD_backAmbientIntensity	48
#define EXPOSED_FIELD_receivedPower	49
#define EXPOSED_FIELD_joints	50
#define EXPOSED_FIELD_articulationParameterArray	51
#define EXPOSED_FIELD_order	52
#define EXPOSED_FIELD_deletionAllowed	53
#define EXPOSED_FIELD_geometry	54
#define EXPOSED_FIELD_translation	55
#define EXPOSED_FIELD_address	56
#define EXPOSED_FIELD_multicastRelayPort	57
#define EXPOSED_FIELD_watchList	58
#define EXPOSED_FIELD_limitOrientation	59
#define EXPOSED_FIELD_skeleton	60
#define EXPOSED_FIELD_lineProperties	61
#define EXPOSED_FIELD_data	62
#define EXPOSED_FIELD_centerOfRotation	63
#define EXPOSED_FIELD_minBack	64
#define EXPOSED_FIELD_type	65
#define EXPOSED_FIELD_writeInterval	66
#define EXPOSED_FIELD_backShininess	67
#define EXPOSED_FIELD_entityID	68
#define EXPOSED_FIELD_fired2	69
#define EXPOSED_FIELD_closed	70
#define EXPOSED_FIELD_eventApplicationID	71
#define EXPOSED_FIELD_applicationID	72
#define EXPOSED_FIELD_global	73
#define EXPOSED_FIELD_vTessellation	74
#define EXPOSED_FIELD_displacers	75
#define EXPOSED_FIELD_minVal	76
#define EXPOSED_FIELD_back	77
#define EXPOSED_FIELD_pressTime	78
#define EXPOSED_FIELD_bboxCenter	79
#define EXPOSED_FIELD_emissiveColor	80
#define EXPOSED_FIELD_geoCenter	81
#define EXPOSED_FIELD_antennaPatternLength	82
#define EXPOSED_FIELD_centerOfMass	83
#define EXPOSED_FIELD_filled	84
#define EXPOSED_FIELD_groundAngle	85
#define EXPOSED_FIELD_mapping	86
#define EXPOSED_FIELD_mode	87
#define EXPOSED_FIELD_string	88
#define EXPOSED_FIELD_children	89
#define EXPOSED_FIELD_map	90
#define EXPOSED_FIELD_on	91
#define EXPOSED_FIELD_leftUrl	92
#define EXPOSED_FIELD_textureCompression	93
#define EXPOSED_FIELD_warhead	94
#define EXPOSED_FIELD_frontTexture	95
#define EXPOSED_FIELD_entityCategory	96
#define EXPOSED_FIELD_diskAngle	97
#define EXPOSED_FIELD_transmitFrequencyBandwidth	98
#define EXPOSED_FIELD_dataLength	99
#define EXPOSED_FIELD_shininess	100
#define EXPOSED_FIELD_texturePriority	101
#define EXPOSED_FIELD_description	102
#define EXPOSED_FIELD_radioEntityTypeCategory	103
#define EXPOSED_FIELD_top	104
#define EXPOSED_FIELD_dropOffRate	105
#define EXPOSED_FIELD_fuse	106
#define EXPOSED_FIELD_family	107
#define EXPOSED_FIELD_width	108
#define EXPOSED_FIELD_skinNormal	109
#define EXPOSED_FIELD_source	110
#define EXPOSED_FIELD_front	111
#define EXPOSED_FIELD_linearVelocity	112
#define EXPOSED_FIELD_entityDomain	113
#define EXPOSED_FIELD_backUrl	114
#define EXPOSED_FIELD_size	115
#define EXPOSED_FIELD_boundaryModeT	116
#define EXPOSED_FIELD_maxExtent	117
#define EXPOSED_FIELD_summary	118
#define EXPOSED_FIELD_transmitState	119
#define EXPOSED_FIELD_buttonPress	120
#define EXPOSED_FIELD_readInterval	121
#define EXPOSED_FIELD_materialIndex	122
#define EXPOSED_FIELD_style	123
#define EXPOSED_FIELD_tdlType	124
#define EXPOSED_FIELD_radioEntityTypeDomain	125
#define EXPOSED_FIELD_hatchColor	126
#define EXPOSED_FIELD_bottom	127
#define EXPOSED_FIELD_marking	128
#define EXPOSED_FIELD_backSpecularColor	129
#define EXPOSED_FIELD_ambientIntensity	130
#define EXPOSED_FIELD_modulationTypeSystem	131
#define EXPOSED_FIELD_frontUrl	132
#define EXPOSED_FIELD_headlight	133
#define EXPOSED_FIELD_highResolution	134
#define EXPOSED_FIELD_radioEntityTypeKind	135
#define EXPOSED_FIELD_cycleInterval	136
#define EXPOSED_FIELD_dimension	137
#define EXPOSED_FIELD_mass	138
#define EXPOSED_FIELD_pitch	139
#define EXPOSED_FIELD_articulationParameterTypeArray	140
#define EXPOSED_FIELD_modulationTypeDetail	141
#define EXPOSED_FIELD_bottomTexture	142
#define EXPOSED_FIELD_separateBackColor	143
#define EXPOSED_FIELD_sites	144
#define EXPOSED_FIELD_encodingScheme	145
#define EXPOSED_FIELD_maxVal	146
#define EXPOSED_FIELD_fired1	147
#define EXPOSED_FIELD_depth	148
#define EXPOSED_FIELD_parameter	149
#define EXPOSED_FIELD_borderWidth	150
#define EXPOSED_FIELD_backTransparency	151
#define EXPOSED_FIELD_tessellation	152
#define EXPOSED_FIELD_fieldOfView	153
#define EXPOSED_FIELD_scale	154
#define EXPOSED_FIELD_renderCulling	155
#define EXPOSED_FIELD_borderColor	156
#define EXPOSED_FIELD_ambientColor	157
#define EXPOSED_FIELD_maxFront	158
#define EXPOSED_FIELD_rightTexture	159
#define EXPOSED_FIELD_uTessellation	160
#define EXPOSED_FIELD_skinCoordWeight	161
#define EXPOSED_FIELD_plane	162
#define EXPOSED_FIELD_keyValue	163
#define EXPOSED_FIELD_radius	164
#define EXPOSED_FIELD_bottomRadius	165
#define EXPOSED_FIELD_controlPoint	166
#define EXPOSED_FIELD_tessellationScale	167
#define EXPOSED_FIELD_diffuseColor	168
#define EXPOSED_FIELD_startIndex	169
#define EXPOSED_FIELD_point	170
#define EXPOSED_FIELD_inputSource	171
#define EXPOSED_FIELD_radioEntityTypeNomenclatureVersion	172
#define EXPOSED_FIELD_normal	173
#define EXPOSED_FIELD_keyWeight	174
#define EXPOSED_FIELD_articulationParameterChangeIndicatorArr	175
#define EXPOSED_FIELD_firingRate	176
#define EXPOSED_FIELD_entitySpecific	177
#define EXPOSED_FIELD_eventNumber	178
#define EXPOSED_FIELD_loop	179
#define EXPOSED_FIELD_key	180
#define EXPOSED_FIELD_ulimit	181
#define EXPOSED_FIELD_skinCoord	182
#define EXPOSED_FIELD_enabled	183
#define EXPOSED_FIELD_name	184
#define EXPOSED_FIELD_texCoord	185
#define EXPOSED_FIELD_pickable	186
#define EXPOSED_FIELD_hatched	187
#define EXPOSED_FIELD_shapeType	188
#define EXPOSED_FIELD_articulationParameterCount	189
#define EXPOSED_FIELD_collide	190
#define EXPOSED_FIELD_avatarSize	191
#define EXPOSED_FIELD_specularColor	192
#define EXPOSED_FIELD_easeInEaseOut	193
#define EXPOSED_FIELD_transitionTime	194
#define EXPOSED_FIELD_siteID	195
#define EXPOSED_FIELD_color	196
#define EXPOSED_FIELD_axisOfRotation	197
#define EXPOSED_FIELD_networkMode	198
#define EXPOSED_FIELD_backEmissiveColor	199
#define EXPOSED_FIELD_transparency	200
#define EXPOSED_FIELD_linearAcceleration	201
#define EXPOSED_FIELD_textureTransform	202
#define EXPOSED_FIELD_lengthOfModulationParameters	203
#define EXPOSED_FIELD_height	204
#define EXPOSED_FIELD_viewpoints	205
#define EXPOSED_FIELD_length	206
#define EXPOSED_FIELD_right	207
#define EXPOSED_FIELD_index	208
#define EXPOSED_FIELD_pickingGeometry	209
#define EXPOSED_FIELD_intensity	210
#define EXPOSED_FIELD_update	211
#define EXPOSED_FIELD_navType	212
#define EXPOSED_FIELD_entityCountry	213
#define EXPOSED_FIELD_heightAngle	214
#define EXPOSED_FIELD_antennaPatternType	215
#define EXPOSED_FIELD_minAngle	216
#define EXPOSED_FIELD_weight	217
#define EXPOSED_FIELD_visibilityLimit	218
#define EXPOSED_FIELD_munitionApplicationID	219
#define EXPOSED_FIELD_value	220
#define EXPOSED_FIELD_articulationParameterIdPartAttachedToAr	221
#define EXPOSED_FIELD_multicastRelayHost	222
#define EXPOSED_FIELD_forceID	223
#define EXPOSED_FIELD_articulationParameterDesignatorArray	224
#define EXPOSED_FIELD_stopTime	225
#define EXPOSED_FIELD_position	226
#define EXPOSED_FIELD_faceType	227
#define EXPOSED_FIELD_magnificationFilter	228
#define EXPOSED_FIELD_controller	229
#define EXPOSED_FIELD_fogCoord	230
#define EXPOSED_FIELD_scaleOrientation	231
#define EXPOSED_FIELD_munitionEndPoint	232
#define EXPOSED_FIELD_choice	233
#define EXPOSED_FIELD_bottomUrl	234
#define EXPOSED_FIELD_radioID	235
#define EXPOSED_FIELD_boundaryModeS	236
#define EXPOSED_FIELD_hatchStyle	237
#define EXPOSED_FIELD_cutOffAngle	238
#define EXPOSED_FIELD_justification	239
#define EXPOSED_FIELD_fogType	240
#define EXPOSED_FIELD_spacing	241
#define EXPOSED_FIELD_skyColor	242
#define EXPOSED_FIELD_minPosition	243
#define EXPOSED_FIELD_displacements	244
#define EXPOSED_FIELD_topUrl	245
#define EXPOSED_FIELD_linewidthScaleFactor	246
#define EXPOSED_FIELD_detonationLocation	247
#define EXPOSED_FIELD_attenuation	248
#define EXPOSED_FIELD_FreeWRL_PROTOInterfaceNodes	249
#define EXPOSED_FIELD_fireMissionIndex	250
#define EXPOSED_FIELD_entityExtra	251
#define EXPOSED_FIELD_url	252
#define EXPOSED_FIELD_coord	253
#define EXPOSED_FIELD_startTime	254
#define EXPOSED_FIELD_minFront	255
#define EXPOSED_FIELD_displayed	256
#define EXPOSED_FIELD_focalDistance	257
#define EXPOSED_FIELD_deviceName	258
#define EXPOSED_FIELD_boundaryModeR	259
#define EXPOSED_FIELD_level	260
#define EXPOSED_FIELD_intValue	261
#define EXPOSED_FIELD_vertexCount	262
#define EXPOSED_FIELD_transitionType	263
#define EXPOSED_FIELD_applied	264
#define EXPOSED_FIELD_backTexture	265
#define EXPOSED_FIELD_llimit	266
#define EXPOSED_FIELD_function	267
#define EXPOSED_FIELD_range	268
#define EXPOSED_FIELD_channel	269
#define EXPOSED_FIELD_resumeTime	270
#define EXPOSED_FIELD_velocity	271
#define EXPOSED_FIELD_antennaLocation	272
#define EXPOSED_FIELD_alpha	273
#define EXPOSED_FIELD_vertexOrdering	274
#define EXPOSED_FIELD_radioEntityTypeNomenclature	275
#define EXPOSED_FIELD_bboxSize	276
#define EXPOSED_FIELD_backDiffuseColor	277
#define EXPOSED_FIELD_shaders	278
#define EXPOSED_FIELD_VRML1children	279
#define EXPOSED_FIELD_visibilityRange	280
#define EXPOSED_FIELD_leftTexture	281
#define EXPOSED_FIELD_momentsOfInertia	282
#define EXPOSED_FIELD_coordIndex	283
#define EXPOSED_FIELD_munitionStartPoint	284
#define EXPOSED_FIELD_skinCoordIndex	285
#define EXPOSED_FIELD_material	286
#define EXPOSED_FIELD_priority	287
#define EXPOSED_FIELD_linetype	288
#define EXPOSED_FIELD_receiverState	289
#define EXPOSED_FIELD_transmitterApplicationID	290
#define EXPOSED_FIELD_frequency	291
#define EXPOSED_FIELD_eventEntityID	292
#define EXPOSED_FIELD_pressLength	293
#define EXPOSED_FIELD_rtpHeaderExpected	294
#define EXPOSED_FIELD_pauseTime	295
#define EXPOSED_FIELD_normalizeVelocity	296
#define EXPOSED_FIELD_metadata	297
#define EXPOSED_FIELD_geoCoords	298
#define EXPOSED_FIELD_relativeAntennaLocation	299
#define EXPOSED_FIELD_normalIndex	300
#define EXPOSED_FIELD_beamWidth	301
#define EXPOSED_FIELD_pickTarget	302
#define EXPOSED_FIELD_location	303
#define EXPOSED_FIELD_jump	304
#define EXPOSED_FIELD_port	305
#define EXPOSED_FIELD_whichGeometry	306
#define EXPOSED_FIELD_timeOut	307
#define EXPOSED_FIELD_skyAngle	308
#define EXPOSED_FIELD_eventSiteID	309
#define EXPOSED_FIELD_useIntValue	310
#define EXPOSED_FIELD_fontStyle	311
#define EXPOSED_FIELD_orientation	312
#define EXPOSED_FIELD_whichChild	313
#define EXPOSED_FIELD_appearance	314
#define EXPOSED_FIELD_center	315
#define EXPOSED_FIELD_autoOffset	316
#define EXPOSED_FIELD_wrapT	317
#define EXPOSED_FIELD_munitionEntityID	318
#define EXPOSED_FIELD_maxDelta	319
#define EXPOSED_FIELD_floatValue	320
#define EXPOSED_FIELD_offset	321
#define EXPOSED_FIELD_entitySubCategory	322
#define EXPOSED_FIELD_munitionQuantity	323
#define EXPOSED_FIELD_cryptoSystem	324
#define EXPOSED_FIELD_numPoints	325
#define EXPOSED_FIELD_cryptoKeyID	326
#define EXPOSED_FIELD_anisotropicDegree	327
#define EXPOSED_FIELD_parts	328
#define EXPOSED_FIELD_keyVelocity	329
#define EXPOSED_FIELD_collisionType	330


/* Table of built-in fieldIds */
extern const char *FIELD[];
extern const int FIELD_COUNT;
#define FIELD_rootNode	0
#define FIELD_category	1
#define FIELD_extra	2
#define FIELD_load	3
#define FIELD_horizontal	4
#define FIELD_yScale	5
#define FIELD_fanCount	6
#define FIELD_title	7
#define FIELD_child4Url	8
#define FIELD_geoGridOrigin	9
#define FIELD_stripCount	10
#define FIELD_deviceMinVal	11
#define FIELD_repeatT	12
#define FIELD_texCoordIndex	13
#define FIELD_intersectionType	14
#define FIELD_beginCap	15
#define FIELD_speedFactor	16
#define FIELD_topToBottom	17
#define FIELD_FreeWRL__protoDef	18
#define FIELD_height	19
#define FIELD_colorIndex	20
#define FIELD_startAngle	21
#define FIELD_textureProperties	22
#define FIELD_child2Url	23
#define FIELD_crossSection	24
#define FIELD_xSpacing	25
#define FIELD_numComponents	26
#define FIELD_creaseAngle	27
#define FIELD_knot	28
#define FIELD_bboxCenter	29
#define FIELD_xDimension	30
#define FIELD_spacing	31
#define FIELD_solid	32
#define FIELD_geoSystem	33
#define FIELD_rootUrl	34
#define FIELD_sortOrder	35
#define FIELD_endAngle	36
#define FIELD_ccw	37
#define FIELD_subcategory	38
#define FIELD_outerRadius	39
#define FIELD_family	40
#define FIELD_specific	41
#define FIELD_leftToRight	42
#define FIELD_range	43
#define FIELD_domain	44
#define FIELD_kind	45
#define FIELD_repeatS	46
#define FIELD_forceTransitions	47
#define FIELD_bboxSize	48
#define FIELD_country	49
#define FIELD_info	50
#define FIELD_language	51
#define FIELD_style	52
#define FIELD_lineSegments	53
#define FIELD_justify	54
#define FIELD_side	55
#define FIELD_coordIndex	56
#define FIELD_deviceMaxVal	57
#define FIELD_rtpHeaderExpected	58
#define FIELD_child3Url	59
#define FIELD_spatialize	60
#define FIELD_geoOrigin	61
#define FIELD_rotateYUp	62
#define FIELD_normalIndex	63
#define FIELD_colorPerVertex	64
#define FIELD_zSpacing	65
#define FIELD_directOutput	66
#define FIELD_generateMipMaps	67
#define FIELD_innerRadius	68
#define FIELD_proxy	69
#define FIELD_closureType	70
#define FIELD_convex	71
#define FIELD_child1Url	72
#define FIELD_endCap	73
#define FIELD_zDimension	74
#define FIELD_reference	75
#define FIELD_spine	76
#define FIELD_bottomRadius	77
#define FIELD_mustEvaluate	78
#define FIELD_normalPerVertex	79


/* Table of built-in keywords */
extern const char *KEYWORDS[];
extern const int KEYWORDS_COUNT;
#define KW_eventOut	0
#define KW_TRUE	1
#define KW_NULL	2
#define KW_IS	3
#define KW_EXTERNPROTO	4
#define KW_inputOnly	5
#define KW_DEF	6
#define KW_PROTO	7
#define KW_IMPORT	8
#define KW_initializeOnly	9
#define KW_outputOnly	10
#define KW_FALSE	11
#define KW_inputOutput	12
#define KW_field	13
#define KW_TO	14
#define KW_PROFILE	15
#define KW_exposedField	16
#define KW_COMPONENT	17
#define KW_eventIn	18
#define KW_META	19
#define KW_EXPORT	20
#define KW_USE	21
#define KW_ROUTE	22

const char *stringKeywordType(int st);

/* Table of built-in profiles */
extern const char *PROFILES[];
extern const int PROFILES_COUNT;
#define PRO_Interchange	0
#define PRO_CADInterchange	1
#define PRO_MPEG4	2
#define PRO_Interactive	3
#define PRO_Full	4
#define PRO_Immersive	5
#define PRO_Core	6

const char *stringProfileType(int st);

/* Table of built-in components */
extern const char *COMPONENTS[];
extern const int COMPONENTS_COUNT;
#define COM_Geometry2D	0
#define COM_Rendering	1
#define COM_PickingSensor	2
#define COM_DIS	3
#define COM_EnvironmentalSensor	4
#define COM_Text	5
#define COM_NURBS	6
#define COM_CubeMapTexturing	7
#define COM_EventUtilities	8
#define COM_Interpolation	9
#define COM_Shaders	10
#define COM_Navigation	11
#define COM_Grouping	12
#define COM_Texturing	13
#define COM_Geospatial	14
#define COM_CADGeometry	15
#define COM_EnvironmentalEffects	16
#define COM_Shape	17
#define COM_Texturing3D	18
#define COM_PointDeviceSensor	19
#define COM_HAnim	20
#define COM_RigidBodyPhysics	21
#define COM_Core	22
#define COM_Layout	23
#define COM_Time	24
#define COM_Geometry3D	25
#define COM_Followers	26
#define COM_Scripting	27
#define COM_Lighting	28
#define COM_KeyDeviceSensor	29
#define COM_Layering	30
#define COM_Networking	31
#define COM_ParticleSystems	32
#define COM_Sound	33

const char *stringComponentType(int st);

/* Table of built-in PROTO keywords */
extern const char *PROTOKEYWORDS[];
extern const int PROTOKEYWORDS_COUNT;
#define PKW_eventOut	0
#define PKW_exposedField	1
#define PKW_inputOnly	2
#define PKW_eventIn	3
#define PKW_outputOnly	4
#define PKW_initializeOnly	5
#define PKW_inputOutput	6
#define PKW_field	7

const char *stringPROTOKeywordType(int st);

/* Table of built-in X3DSPECIAL keywords */
extern const char *X3DSPECIAL[];
extern const int X3DSPECIAL_COUNT;
#define X3DSP_IS	0
#define X3DSP_Scene	1
#define X3DSP_meta	2
#define X3DSP_export	3
#define X3DSP_ProtoDeclare	4
#define X3DSP_field	5
#define X3DSP_connect	6
#define X3DSP_head	7
#define X3DSP_ProtoInterface	8
#define X3DSP_ProtoInstance	9
#define X3DSP_ProtoBody	10
#define X3DSP_X3D	11
#define X3DSP_import	12
#define X3DSP_component	13
#define X3DSP_ExternProtoDeclare	14
#define X3DSP_fieldValue	15
#define X3DSP_ROUTE	16
#define X3DSP_Header	17

const char *stringX3DSPECIALType(int st);

/* Table of built-in TEXTUREBOUNDARY keywords */
extern const char *TEXTUREBOUNDARYKEYWORDS[];
extern const int TEXTUREBOUNDARYKEYWORDS_COUNT;
#define TB_CLAMP_TO_BOUNDARY	0
#define TB_REPEAT	1
#define TB_MIRRORED_REPEAT	2
#define TB_CLAMP	3
#define TB_CLAMP_TO_EDGE	4

const char *stringTEXTUREBOUNDARYKeywordType(int st);

/* Table of built-in TEXTUREMAGNIFICATION keywords */
extern const char *TEXTUREMAGNIFICATIONKEYWORDS[];
extern const int TEXTUREMAGNIFICATIONKEYWORDS_COUNT;
#define TMAG_NICEST	0
#define TMAG_NEAREST_PIXEL	1
#define TMAG_FASTEST	2
#define TMAG_DEFAULT	3
#define TMAG_AVG_PIXEL	4

const char *stringTEXTUREMAGNIFICATIONKeywordType(int st);

/* Table of built-in TEXTUREMINIFICATION keywords */
extern const char *TEXTUREMINIFICATIONKEYWORDS[];
extern const int TEXTUREMINIFICATIONKEYWORDS_COUNT;
#define TMIN_NEAREST_PIXEL_AVG_MIPMAP	0
#define TMIN_DEFAULT	1
#define TMIN_NEAREST_PIXEL	2
#define TMIN_NICEST	3
#define TMIN_AVG_PIXEL_AVG_MIPMAP	4
#define TMIN_FASTEST	5
#define TMIN_AVG_PIXEL	6
#define TMIN_AVG_PIXEL_NEAREST_MIPMAP	7
#define TMIN_NEAREST_PIXEL_NEAREST_MIPMAP	8

const char *stringTEXTUREMINIFICATIONKeywordType(int st);

/* Table of built-in TEXTURECOMPRESSION keywords */
extern const char *TEXTURECOMPRESSIONKEYWORDS[];
extern const int TEXTURECOMPRESSIONKEYWORDS_COUNT;
#define TC_NICEST	0
#define TC_LOW	1
#define TC_FASTEST	2
#define TC_DEFAULT	3
#define TC_HIGH	4
#define TC_MEDIUM	5

const char *stringTEXTURECOMPRESSIONKeywordType(int st);

/* Table of built-in VRML1Modifier keywords */
extern const char *VRML1Modifier[];
extern const int VRML1Modifier_COUNT;
#define VRML1MOD_REPEAT	0
#define VRML1MOD_ITALIC	1
#define VRML1MOD_PER_PART_INDEXED	2
#define VRML1MOD_PER_VERTEX_INDEXED	3
#define VRML1MOD_AUTO	4
#define VRML1MOD_TYPEWRITER	5
#define VRML1MOD_OVERALL	6
#define VRML1MOD_UNKNOWN_SHAPE_TYPE	7
#define VRML1MOD_SERIF	8
#define VRML1MOD_COUNTERCLOCKWISE	9
#define VRML1MOD_CLOCKWISE	10
#define VRML1MOD_POINT	11
#define VRML1MOD_PER_PART	12
#define VRML1MOD_SOLID	13
#define VRML1MOD_ALL	14
#define VRML1MOD_TOP	15
#define VRML1MOD_RIGHT	16
#define VRML1MOD_SIDES	17
#define VRML1MOD_BOLD	18
#define VRML1MOD_BOTTOM	19
#define VRML1MOD_LEFT	20
#define VRML1MOD_CONVEX	21
#define VRML1MOD_UNKNOWN_FACE_TYPE	22
#define VRML1MOD_SANS	23
#define VRML1MOD_UNKNOWN_ORDERING	24
#define VRML1MOD_PER_FACE	25
#define VRML1MOD_PER_VERTEX	26
#define VRML1MOD_NONE	27
#define VRML1MOD_PER_FACE_INDEXED	28
#define VRML1MOD_DEFAULT	29
#define VRML1MOD_ON	30
#define VRML1MOD_CLAMP	31
#define VRML1MOD_CENTER	32
#define VRML1MOD_OFF	33

const char *stringVRML1ModifierType(int st);

/* Table of built-in GEOSPATIAL keywords */
extern const char *GEOSPATIAL[];
extern const int GEOSPATIAL_COUNT;
#define GEOSP_CC	0
#define GEOSP_WE	1
#define GEOSP_GCC	2
#define GEOSP_date	3
#define GEOSP_copyright	4
#define GEOSP_FA	5
#define GEOSP_EC	6
#define GEOSP_UTM	7
#define GEOSP_BN	8
#define GEOSP_ED	9
#define GEOSP_CD	10
#define GEOSP_EF	11
#define GEOSP_GD	12
#define GEOSP_dataFormat	13
#define GEOSP_extent	14
#define GEOSP_metadataFormat	15
#define GEOSP_originator	16
#define GEOSP_dataUrl	17
#define GEOSP_verticalDatum	18
#define GEOSP_description	19
#define GEOSP_WD	20
#define GEOSP_resolution	21
#define GEOSP_coordinateSystem	22
#define GEOSP_RF	23
#define GEOSP_title	24
#define GEOSP_WGS84	25
#define GEOSP_ID	26
#define GEOSP_EB	27
#define GEOSP_HO	28
#define GEOSP_horizontalDatum	29
#define GEOSP_HE	30
#define GEOSP_EE	31
#define GEOSP_AA	32
#define GEOSP_SA	33
#define GEOSP_GC	34
#define GEOSP_AM	35
#define GEOSP_ellipsoid	36
#define GEOSP_IN	37
#define GEOSP_AN	38
#define GEOSP_KA	39
#define GEOSP_GDC	40
#define GEOSP_BR	41
#define GEOSP_EA	42

const char *stringGEOSPATIALType(int st);

/* Table of built-in VRML1_ keywords */
extern const char *VRML1_[];
extern const int VRML1__COUNT;
#define VRML1_VRML1_Rotation	0
#define VRML1_VRML1_Cone	1
#define VRML1_VRML1_PerspectiveCamera	2
#define VRML1_VRML1_ShapeHints	3
#define VRML1_VRML1_LOD	4
#define VRML1_VRML1_Translation	5
#define VRML1_VRML1_MatrixTransform	6
#define VRML1_VRML1_SpotLight	7
#define VRML1_VRML1_Texture2	8
#define VRML1_VRML1_IndexedLineSet	9
#define VRML1_VRML1_OrthographicCamera	10
#define VRML1_VRML1_Switch	11
#define VRML1_VRML1_Scale	12
#define VRML1_VRML1_Cube	13
#define VRML1_VRML1_Separator	14
#define VRML1_VRML1_PointSet	15
#define VRML1_VRML1_FontStyle	16
#define VRML1_VRML1_WWWInline	17
#define VRML1_VRML1_TextureCoordinate2	18
#define VRML1_VRML1_Info	19
#define VRML1_VRML1_DirectionalLight	20
#define VRML1_VRML1_AsciiText	21
#define VRML1_VRML1_Transform	22
#define VRML1_VRML1_Texture2Transform	23
#define VRML1_VRML1_Cylinder	24
#define VRML1_VRML1_Normal	25
#define VRML1_VRML1_WWWAnchor	26
#define VRML1_VRML1_NormalBinding	27
#define VRML1_VRML1_MaterialBinding	28
#define VRML1_VRML1_PointLight	29
#define VRML1_VRML1_IndexedFaceSet	30
#define VRML1_VRML1_Material	31
#define VRML1_VRML1_Coordinate3	32
#define VRML1_VRML1_Sphere	33

const char *stringVRML1_Type(int st);
char mapFieldTypeToEAItype (int st);
int mapEAItypeToFieldType (char st);
int convertToSFType (int st);

/* Table of built-in fieldIds */
extern const char *FIELDTYPES[];
extern const int FIELDTYPES_COUNT;
#define FIELDTYPE_SFFloat	0
#define FIELDTYPE_MFFloat	1
#define FIELDTYPE_SFRotation	2
#define FIELDTYPE_MFRotation	3
#define FIELDTYPE_SFVec3f	4
#define FIELDTYPE_MFVec3f	5
#define FIELDTYPE_SFBool	6
#define FIELDTYPE_MFBool	7
#define FIELDTYPE_SFInt32	8
#define FIELDTYPE_MFInt32	9
#define FIELDTYPE_SFNode	10
#define FIELDTYPE_MFNode	11
#define FIELDTYPE_SFColor	12
#define FIELDTYPE_MFColor	13
#define FIELDTYPE_SFColorRGBA	14
#define FIELDTYPE_MFColorRGBA	15
#define FIELDTYPE_SFTime	16
#define FIELDTYPE_MFTime	17
#define FIELDTYPE_SFString	18
#define FIELDTYPE_MFString	19
#define FIELDTYPE_SFVec2f	20
#define FIELDTYPE_MFVec2f	21
#define FIELDTYPE_SFImage	22
#define FIELDTYPE_FreeWRLPTR	23
#define FIELDTYPE_SFVec3d	24
#define FIELDTYPE_MFVec3d	25
#define FIELDTYPE_SFDouble	26
#define FIELDTYPE_MFDouble	27
#define FIELDTYPE_SFMatrix3f	28
#define FIELDTYPE_MFMatrix3f	29
#define FIELDTYPE_SFMatrix3d	30
#define FIELDTYPE_MFMatrix3d	31
#define FIELDTYPE_SFMatrix4f	32
#define FIELDTYPE_MFMatrix4f	33
#define FIELDTYPE_SFMatrix4d	34
#define FIELDTYPE_MFMatrix4d	35
#define FIELDTYPE_SFVec2d	36
#define FIELDTYPE_MFVec2d	37
#define FIELDTYPE_SFVec4f	38
#define FIELDTYPE_MFVec4f	39
#define FIELDTYPE_SFVec4d	40
#define FIELDTYPE_MFVec4d	41

/*cstruct*/
struct Multi_Float { int n; float  *p; };
struct SFRotation { float c[4]; };
struct Multi_Rotation { int n; struct SFRotation  *p; };

struct Multi_Vec3f { int n; struct SFColor  *p; };
/*cstruct*/
struct Multi_Bool { int n; int  *p; };
/*cstruct*/
struct Multi_Int32 { int n; int  *p; };

struct Multi_Node { int n; void * *p; };
struct SFColor { float c[3]; };
struct Multi_Color { int n; struct SFColor  *p; };
struct SFColorRGBA { float c[4]; };
struct Multi_ColorRGBA { int n; struct SFColorRGBA  *p; };
/*cstruct*/
struct Multi_Time { int n; double  *p; };
/*cstruct*/
struct Multi_String { int n; struct Uni_String * *p; };
struct SFVec2f { float c[2]; };
struct Multi_Vec2f { int n; struct SFVec2f  *p; };
/*cstruct*/
/*cstruct*/
struct SFVec3d { double c[3]; };
struct Multi_Vec3d { int n; struct SFVec3d  *p; };
/*cstruct*/
struct Multi_Double { int n; double  *p; };
struct SFMatrix3f { float c[9]; };
struct Multi_Matrix3f { int n; struct SFMatrix3f  *p; };
struct SFMatrix3d { double c[9]; };
struct Multi_Matrix3d { int n; struct SFMatrix3d  *p; };
struct SFMatrix4f { float c[16]; };
struct Multi_Matrix4f { int n; struct SFMatrix4f  *p; };
struct SFMatrix4d { double c[16]; };
struct Multi_Matrix4d { int n; struct SFMatrix4d  *p; };
struct SFVec2d { double c[2]; };
struct Multi_Vec2d { int n; struct SFVec2d  *p; };
struct SFVec4f { float c[4]; };
struct Multi_Vec4f { int n; struct SFVec4f  *p; };
struct SFVec4d { double c[4]; };
struct Multi_Vec4d { int n; struct SFVec4d  *p; };
const char *stringFieldtypeType(int st);

/* Table of built-in nodeIds */
extern const char *NODES[];
extern const int NODES_COUNT;

/* and now the structs for the nodetypes */ 
const char *stringNodeType(int st);

/* First, a generic struct, contains only the common elements */
struct X3D_Node {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
};
#define X3D_NODE(node) ((struct X3D_Node*)node)
#define X3D_GROUP(node) ((struct X3D_Group*)node)
#define X3D_PICKABLEGROUP(node) ((struct X3D_PickableGroup*)node)
#define X3D_POINTPICKSENSOR(node) ((struct X3D_PointPickSensor*)node)
#define X3D_STATICGROUP(node) ((struct X3D_StaticGroup*)node)
#define X3D_ANCHOR(node) ((struct X3D_Anchor*)node)
#define X3D_COLLISION(node) ((struct X3D_Collision*)node)
#define X3D_COMPOSEDSHADER(node) ((struct X3D_ComposedShader*)node)
#define X3D_PACKAGEDSHADER(node) ((struct X3D_PackagedShader*)node)
#define X3D_PROGRAMSHADER(node) ((struct X3D_ProgramShader*)node)
#define X3D_SHADERPROGRAM(node) ((struct X3D_ShaderProgram*)node)
#define X3D_SHAPE(node) ((struct X3D_Shape*)node)
#define X3D_VISIBILITYSENSOR(node) ((struct X3D_VisibilitySensor*)node)
#define X3D_BILLBOARD(node) ((struct X3D_Billboard*)node)
#define X3D_BACKGROUND(node) ((struct X3D_Background*)node)
#define X3D_TEXTUREBACKGROUND(node) ((struct X3D_TextureBackground*)node)
#define X3D_FOG(node) ((struct X3D_Fog*)node)
#define X3D_INLINE(node) ((struct X3D_Inline*)node)
#define X3D_SWITCH(node) ((struct X3D_Switch*)node)
#define X3D_SCRIPT(node) ((struct X3D_Script*)node)
#define X3D_VIEWPOINT(node) ((struct X3D_Viewpoint*)node)
#define X3D_ORTHOVIEWPOINT(node) ((struct X3D_OrthoViewpoint*)node)
#define X3D_LODNODE(node) ((struct X3D_LOD*)node)
#define X3D_TRANSFORM(node) ((struct X3D_Transform*)node)
#define X3D_PROXIMITYSENSOR(node) ((struct X3D_ProximitySensor*)node)
#define X3D_POINTLIGHT(node) ((struct X3D_PointLight*)node)
#define X3D_SPOTLIGHT(node) ((struct X3D_SpotLight*)node)
#define X3D_DIRECTIONALLIGHT(node) ((struct X3D_DirectionalLight*)node)
#define X3D_INDEXEDFACESET(node) ((struct X3D_IndexedFaceSet*)node)
#define VRML1_INDEXEDFACESET(node) ((struct X3D_VRML1_IndexedFaceSet*)node)
#define VRML1_SEPARATOR(node) ((struct X3D_VRML1_Separator*)node)
#define X3D_ELEVATIONGRID(node) ((struct X3D_ElevationGrid*)node)
#define X3D_INDEXEDTRIANGLEFANSET(node) ((struct X3D_IndexedTriangleFanSet*)node)
#define X3D_INDEXEDTRIANGLESET(node) ((struct X3D_IndexedTriangleSet*)node)
#define X3D_INDEXEDTRIANGLESTRIPSET(node) ((struct X3D_IndexedTriangleStripSet*)node)
#define X3D_TRIANGLEFANSET(node) ((struct X3D_TriangleFanSet*)node)
#define X3D_TRIANGLESET(node) ((struct X3D_TriangleSet*)node)
#define X3D_TRIANGLESTRIPSET(node) ((struct X3D_TriangleStripSet*)node)
#define X3D_GEOORIGIN(node) ((struct X3D_GeoOrigin*)node)
#define X3D_GEOLOD(node) ((struct X3D_GeoLOD*)node)
#define X3D_GEOCOORD(node) ((struct X3D_GeoCoordinate*)node)
#define X3D_GEOVIEWPOINT(node) ((struct X3D_GeoViewpoint*)node)
#define X3D_GEOELEVATIONGRID(node) ((struct X3D_GeoElevationGrid*)node)
#define X3D_GEOLOCATION(node) ((struct X3D_GeoLocation*)node)
#define X3D_GEOTRANSFORM(node) ((struct X3D_GeoTransform*)node)
#define X3D_GEOPROXIMITYSENSOR(node) ((struct X3D_GeoProximitySensor*)node)
#undef DEBUG_VALIDNODE
#ifdef DEBUG_VALIDNODE	
#define X3D_NODE_CHECK(node) checkNode(node,__FILE__,__LINE__)
#define MARK_EVENT(node,offset) mark_event_check(node,(int) offset,__FILE__,__LINE__)
#else
#define X3D_NODE_CHECK(node)
#define MARK_EVENT(node,offset)	mark_event(node,(int) offset)
#endif
#define COPY_SFVEC3F_TO_POINT_XYZ(too,from) { too.x = from[0]; too.y = from[1]; too.z = from[2];}
#define COPY_POINT_XYZ_TO_SFVEC3F(too,from) { too[0] = (float) from.x; too[1] = (float) from.y; too[2] = (float) from.z;}
#define offsetPointer_deref(t, me, offs) ((t)(((char*)(me))+offs))

/* now, generated structures for each VRML/X3D Node*/
/***********************/
struct X3D_Anchor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * _parentResource;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	struct Uni_String *description;
	void *metadata;
	struct Multi_String parameter;
	struct Multi_Node removeChildren;
	struct Multi_String url;
};
extern struct X3D_Virt virt_Anchor;
/***********************/
struct X3D_Appearance {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *fillProperties;
	void *lineProperties;
	void *material;
	void *metadata;
	struct Multi_Node shaders;
	void *texture;
	void *textureTransform;
};
extern struct X3D_Virt virt_Appearance;
/***********************/
struct X3D_Arc2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __numPoints;
	void * __points;
	float endAngle;
	void *metadata;
	float radius;
	float startAngle;
};
extern struct X3D_Virt virt_Arc2D;
/***********************/
struct X3D_ArcClose2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __numPoints;
	void * __points;
	struct Uni_String *closureType;
	float endAngle;
	void *metadata;
	float radius;
	int solid;
	float startAngle;
};
extern struct X3D_Virt virt_ArcClose2D;
/***********************/
struct X3D_AudioClip {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double __inittime;
	void * __localFileName;
	int __sourceNumber;
	void * _parentResource;
	struct Uni_String *description;
	double duration_changed;
	double elapsedTime;
	int isActive;
	int isPaused;
	int loop;
	void *metadata;
	double pauseTime;
	float pitch;
	double resumeTime;
	double startTime;
	double stopTime;
	struct Multi_String url;
};
extern struct X3D_Virt virt_AudioClip;
/***********************/
struct X3D_AudioControl {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	double __oldLen;
	float deltaFloatVal;
	int deltaInt32Val;
	struct SFColor direction;
	int enabled;
	float intensity;
	int isActive;
	struct SFColor location;
	float maxBack;
	float maxDelta;
	float maxFront;
	void *metadata;
	float minBack;
	float minFront;
	float panFloatVal;
	int panInt32Val;
	struct Uni_String *source;
	float volumeFloatVal;
	int volumeInt32Val;
};
extern struct X3D_Virt virt_AudioControl;
/***********************/
struct X3D_Background {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	void *__backTexture;
	void *__bottomTexture;
	void * __colours;
	void *__frontTexture;
	void *__leftTexture;
	void * __points;
	int __quadcount;
	void *__rightTexture;
	int __textureright;
	void *__topTexture;
	void * _parentResource;
	struct Multi_String backUrl;
	double bindTime;
	struct Multi_String bottomUrl;
	struct Multi_String frontUrl;
	struct Multi_Float groundAngle;
	struct Multi_Color groundColor;
	int isBound;
	struct Multi_String leftUrl;
	void *metadata;
	struct Multi_String rightUrl;
	int set_bind;
	struct Multi_Float skyAngle;
	struct Multi_Color skyColor;
	struct Multi_String topUrl;
	float transparency;
};
extern struct X3D_Virt virt_Background;
/***********************/
struct X3D_Billboard {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double _rotationAngle;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor axisOfRotation;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	void *metadata;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_Billboard;
/***********************/
struct X3D_BooleanFilter {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int inputFalse;
	int inputNegate;
	int inputTrue;
	void *metadata;
	int set_boolean;
};
extern struct X3D_Virt virt_BooleanFilter;
/***********************/
struct X3D_BooleanSequencer {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Bool keyValue;
	void *metadata;
	int next;
	int previous;
	float set_fraction;
	int value_changed;
};
extern struct X3D_Virt virt_BooleanSequencer;
/***********************/
struct X3D_BooleanToggle {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	int set_boolean;
	int toggle;
};
extern struct X3D_Virt virt_BooleanToggle;
/***********************/
struct X3D_BooleanTrigger {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	double set_triggerTime;
	int triggerTrue;
};
extern struct X3D_Virt virt_BooleanTrigger;
/***********************/
struct X3D_Box {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __points;
	void *metadata;
	struct SFColor size;
	int solid;
};
extern struct X3D_Virt virt_Box;
/***********************/
struct X3D_Circle2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __numPoints;
	void * __points;
	void *metadata;
	float radius;
};
extern struct X3D_Virt virt_Circle2D;
/***********************/
struct X3D_ClipPlane {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int enabled;
	void *metadata;
	struct SFVec4f plane;
};
extern struct X3D_Virt virt_ClipPlane;
/***********************/
struct X3D_Collision {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __hit;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	int collide;
	double collideTime;
	int enabled;
	void *metadata;
	void *proxy;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_Collision;
/***********************/
struct X3D_Color {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Color color;
	void *metadata;
};
extern struct X3D_Virt virt_Color;
/***********************/
struct X3D_ColorInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Color keyValue;
	void *metadata;
	float set_fraction;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_ColorInterpolator;
/***********************/
struct X3D_ColorRGBA {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_ColorRGBA color;
	void *metadata;
};
extern struct X3D_Virt virt_ColorRGBA;
/***********************/
struct X3D_ComposedCubeMapTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * _parentResource;
	void *back;
	void *bottom;
	void *front;
	void *left;
	void *metadata;
	void *right;
	void *top;
};
extern struct X3D_Virt virt_ComposedCubeMapTexture;
/***********************/
struct X3D_ComposedShader {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __initialized;
	struct Multi_Int32 __shaderIDS;
	void * __shaderObj;
	int activate;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	void *metadata;
	struct Multi_Node parts;
};
extern struct X3D_Virt virt_ComposedShader;
/***********************/
struct X3D_Cone {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __botpoints;
	int __coneTriangles;
	int __coneVBO;
	void * __normals;
	void * __sidepoints;
	int bottom;
	float bottomRadius;
	float height;
	void *metadata;
	int side;
	int solid;
};
extern struct X3D_Virt virt_Cone;
/***********************/
struct X3D_Contour2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Multi_Node children;
	void *metadata;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_Contour2D;
/***********************/
struct X3D_ContourPolyLine2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
};
extern struct X3D_Virt virt_ContourPolyLine2D;
/***********************/
struct X3D_Coordinate {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Multi_Vec3f point;
};
extern struct X3D_Virt virt_Coordinate;
/***********************/
struct X3D_CoordinateInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	void *metadata;
	float set_fraction;
	struct Multi_Vec3f value_changed;
};
extern struct X3D_Virt virt_CoordinateInterpolator;
/***********************/
struct X3D_CoordinateInterpolator2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	void *metadata;
	float set_fraction;
	struct Multi_Vec2f value_changed;
};
extern struct X3D_Virt virt_CoordinateInterpolator2D;
/***********************/
struct X3D_Cylinder {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __cylinderTriangles;
	int __cylinderVBO;
	void * __normals;
	void * __points;
	int bottom;
	float height;
	void *metadata;
	float radius;
	int side;
	int solid;
	int top;
};
extern struct X3D_Virt virt_Cylinder;
/***********************/
struct X3D_CylinderSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	int _dlchange;
	struct SFRotation _oldrotation;
	struct SFColor _oldtrackPoint;
	struct SFColor _origPoint;
	float _radius;
	int autoOffset;
	struct Uni_String *description;
	float diskAngle;
	int enabled;
	int isActive;
	int isOver;
	float maxAngle;
	void *metadata;
	float minAngle;
	float offset;
	struct SFRotation rotation_changed;
	struct SFColor trackPoint_changed;
};
extern struct X3D_Virt virt_CylinderSensor;
/***********************/
struct X3D_DISEntityManager {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node addedEntities;
	struct Uni_String *address;
	int applicationID;
	struct Multi_Node mapping;
	void *metadata;
	int port;
	struct Multi_Node removedEntities;
	int siteID;
};
extern struct X3D_Virt virt_DISEntityManager;
/***********************/
struct X3D_DISEntityTypeMapping {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int category;
	int country;
	int domain;
	int extra;
	int kind;
	void *metadata;
	int specific;
	int subcategory;
	struct Multi_String url;
};
extern struct X3D_Virt virt_DISEntityTypeMapping;
/***********************/
struct X3D_DirectionalLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFColor color;
	struct SFColor direction;
	int global;
	float intensity;
	void *metadata;
	int on;
};
extern struct X3D_Virt virt_DirectionalLight;
/***********************/
struct X3D_Disk2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __numPoints;
	void * __points;
	int __simpleDisk;
	void * __texCoords;
	float innerRadius;
	void *metadata;
	float outerRadius;
	int solid;
};
extern struct X3D_Virt virt_Disk2D;
/***********************/
struct X3D_EaseInEaseOut {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2f easeInEaseOut;
	struct Multi_Float key;
	void *metadata;
	float modifiedFraction_changed;
	float set_fraction;
};
extern struct X3D_Virt virt_EaseInEaseOut;
/***********************/
struct X3D_ElevationGrid {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	float creaseAngle;
	void *fogCoord;
	struct Multi_Float height;
	void *metadata;
	void *normal;
	int normalPerVertex;
	struct Multi_Float set_height;
	int solid;
	void *texCoord;
	int xDimension;
	float xSpacing;
	int zDimension;
	float zSpacing;
};
extern struct X3D_Virt virt_ElevationGrid;
/***********************/
struct X3D_EspduTransform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct Uni_String *address;
	int applicationID;
	struct Multi_Float articulationParameterArray;
	struct Multi_Int32 articulationParameterChangeIndicatorArr;
	int articulationParameterCount;
	struct Multi_Int32 articulationParameterDesignatorArray;
	struct Multi_Int32 articulationParameterIdPartAttachedToAr;
	struct Multi_Int32 articulationParameterTypeArray;
	float articulationParameterValue0_changed;
	float articulationParameterValue1_changed;
	float articulationParameterValue2_changed;
	float articulationParameterValue3_changed;
	float articulationParameterValue4_changed;
	float articulationParameterValue5_changed;
	float articulationParameterValue6_changed;
	float articulationParameterValue7_changed;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_Node children;
	double collideTime;
	int collisionType;
	int deadReckoning;
	double detonateTime;
	struct SFColor detonationLocation;
	struct SFColor detonationRelativeLocation;
	int detonationResult;
	int enabled;
	int entityCategory;
	int entityCountry;
	int entityDomain;
	int entityExtra;
	int entityID;
	int entityKind;
	int entitySpecific;
	int entitySubCategory;
	int eventApplicationID;
	int eventEntityID;
	int eventNumber;
	int eventSiteID;
	int fireMissionIndex;
	int fired1;
	int fired2;
	double firedTime;
	float firingRange;
	int firingRate;
	int forceID;
	int fuse;
	int isActive;
	int isCollided;
	int isDetonated;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	struct SFColor linearAcceleration;
	struct SFColor linearVelocity;
	struct Uni_String *marking;
	void *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	int munitionApplicationID;
	struct SFColor munitionEndPoint;
	int munitionEntityID;
	int munitionQuantity;
	int munitionSiteID;
	struct SFColor munitionStartPoint;
	struct Uni_String *networkMode;
	int port;
	double readInterval;
	struct Multi_Node removeChildren;
	struct SFRotation rotation;
	int rtpHeaderExpected;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	float set_articulationParameterValue0;
	float set_articulationParameterValue1;
	float set_articulationParameterValue2;
	float set_articulationParameterValue3;
	float set_articulationParameterValue4;
	float set_articulationParameterValue5;
	float set_articulationParameterValue6;
	float set_articulationParameterValue7;
	int siteID;
	double timestamp;
	struct SFColor translation;
	int warhead;
	double writeInterval;
};
extern struct X3D_Virt virt_EspduTransform;
/***********************/
struct X3D_Extrusion {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int beginCap;
	int ccw;
	int convex;
	float creaseAngle;
	struct Multi_Vec2f crossSection;
	int endCap;
	void *metadata;
	struct Multi_Rotation orientation;
	struct Multi_Vec2f scale;
	struct Multi_Vec2f set_crossSection;
	struct Multi_Rotation set_orientation;
	struct Multi_Vec2f set_scale;
	struct Multi_Vec3f set_spine;
	int solid;
	struct Multi_Vec3f spine;
};
extern struct X3D_Virt virt_Extrusion;
/***********************/
struct X3D_FillProperties {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int filled;
	struct SFColor hatchColor;
	int hatchStyle;
	int hatched;
	void *metadata;
};
extern struct X3D_Virt virt_FillProperties;
/***********************/
struct X3D_FloatVertexAttribute {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	int numComponents;
	struct Multi_Float value;
};
extern struct X3D_Virt virt_FloatVertexAttribute;
/***********************/
struct X3D_Fog {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	double bindTime;
	struct SFColor color;
	struct Uni_String *fogType;
	int isBound;
	void *metadata;
	int set_bind;
	float visibilityRange;
};
extern struct X3D_Virt virt_Fog;
/***********************/
struct X3D_FogCoordinate {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float depth;
	void *metadata;
};
extern struct X3D_Virt virt_FogCoordinate;
/***********************/
struct X3D_FontStyle {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_String family;
	int horizontal;
	struct Multi_String justify;
	struct Uni_String *language;
	int leftToRight;
	void *metadata;
	float size;
	float spacing;
	struct Uni_String *style;
	int topToBottom;
};
extern struct X3D_Virt virt_FontStyle;
/***********************/
struct X3D_GeneratedCubeMapTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __textureTableIndex;
	void *metadata;
	int size;
	void *textureProperties;
	struct Uni_String *update;
};
extern struct X3D_Virt virt_GeneratedCubeMapTexture;
/***********************/
struct X3D_GeoCoordinate {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	struct Multi_Vec3f __movedCoords;
	void *geoOrigin;
	struct Multi_String geoSystem;
	void *metadata;
	struct Multi_Vec3d point;
};
extern struct X3D_Virt virt_GeoCoordinate;
/***********************/
struct X3D_GeoElevationGrid {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	struct Multi_Int32 _coordIndex;
	int ccw;
	void *color;
	int colorPerVertex;
	double creaseAngle;
	struct SFVec3d geoGridOrigin;
	void *geoOrigin;
	struct Multi_String geoSystem;
	struct Multi_Double height;
	void *metadata;
	void *normal;
	int normalPerVertex;
	struct Multi_Double set_height;
	int solid;
	void *texCoord;
	int xDimension;
	double xSpacing;
	float yScale;
	int zDimension;
	double zSpacing;
};
extern struct X3D_Virt virt_GeoElevationGrid;
/***********************/
struct X3D_GeoLOD {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *__child1Node;
	void *__child2Node;
	void *__child3Node;
	void *__child4Node;
	int __childloadstatus;
	struct Multi_Int32 __geoSystem;
	int __inRange;
	int __level;
	struct SFVec3d __movedCoords;
	void *__rootUrl;
	int __rooturlloadstatus;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFVec3d center;
	struct Multi_String child1Url;
	struct Multi_String child2Url;
	struct Multi_String child3Url;
	struct Multi_String child4Url;
	struct Multi_Node children;
	void *geoOrigin;
	struct Multi_String geoSystem;
	int level_changed;
	void *metadata;
	float range;
	struct Multi_Node rootNode;
	struct Multi_String rootUrl;
};
extern struct X3D_Virt virt_GeoLOD;
/***********************/
struct X3D_GeoLocation {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	struct SFVec4d __localOrient;
	struct SFVec3d __movedCoords;
	struct Multi_Node __oldChildren;
	struct SFVec3d __oldgeoCoords;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	struct SFVec3d geoCoords;
	void *geoOrigin;
	struct Multi_String geoSystem;
	void *metadata;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_GeoLocation;
/***********************/
struct X3D_GeoMetadata {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node data;
	void *metadata;
	struct Multi_String summary;
	struct Multi_String url;
};
extern struct X3D_Virt virt_GeoMetadata;
/***********************/
struct X3D_GeoOrigin {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	struct SFVec3d __movedCoords;
	struct Multi_String __oldMFString;
	struct SFVec3d __oldgeoCoords;
	struct SFVec3d geoCoords;
	struct Multi_String geoSystem;
	void *metadata;
	int rotateYUp;
};
extern struct X3D_Virt virt_GeoOrigin;
/***********************/
struct X3D_GeoPositionInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	struct Multi_Vec3d __movedValue;
	void *__oldKeyPtr;
	void *__oldKeyValuePtr;
	void *geoOrigin;
	struct Multi_String geoSystem;
	struct SFVec3d geovalue_changed;
	struct Multi_Float key;
	struct Multi_Vec3d keyValue;
	void *metadata;
	float set_fraction;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_GeoPositionInterpolator;
/***********************/
struct X3D_GeoProximitySensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	int __hit;
	struct SFVec4d __localOrient;
	struct SFVec3d __movedCoords;
	int __oldEnabled;
	struct SFVec3d __oldGeoCenter;
	struct SFColor __oldSize;
	struct SFColor __t1;
	struct SFRotation __t2;
	struct SFColor centerOfRotation_changed;
	int enabled;
	double enterTime;
	double exitTime;
	struct SFVec3d geoCenter;
	struct SFVec3d geoCoord_changed;
	void *geoOrigin;
	struct Multi_String geoSystem;
	int isActive;
	void *metadata;
	struct SFRotation orientation_changed;
	struct SFColor position_changed;
	struct SFColor size;
};
extern struct X3D_Virt virt_GeoProximitySensor;
/***********************/
struct X3D_GeoTouchSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 __geoSystem;
	int __oldEnabled;
	struct SFColor _oldhitNormal;
	struct SFColor _oldhitPoint;
	struct SFVec2f _oldhitTexCoord;
	struct Uni_String *description;
	int enabled;
	void *geoOrigin;
	struct Multi_String geoSystem;
	struct SFVec3d hitGeoCoord_changed;
	struct SFColor hitNormal_changed;
	struct SFColor hitPoint_changed;
	struct SFVec2f hitTexCoord_changed;
	int isActive;
	int isOver;
	void *metadata;
	double touchTime;
};
extern struct X3D_Virt virt_GeoTouchSensor;
/***********************/
struct X3D_GeoTransform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __do_center;
	int __do_rotation;
	int __do_scale;
	int __do_scaleO;
	int __do_trans;
	struct Multi_Int32 __geoSystem;
	struct SFVec4d __localOrient;
	struct SFVec3d __movedCoords;
	struct Multi_Node __oldChildren;
	struct SFVec3d __oldGeoCenter;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	struct SFVec3d geoCenter;
	void *geoOrigin;
	struct Multi_String geoSystem;
	void *metadata;
	struct Multi_Node removeChildren;
	struct SFRotation rotation;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	struct SFColor translation;
};
extern struct X3D_Virt virt_GeoTransform;
/***********************/
struct X3D_GeoViewpoint {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	struct Multi_Int32 __geoSystem;
	struct SFRotation __movedOrientation;
	struct SFVec3d __movedPosition;
	float __oldFieldOfView;
	int __oldHeadlight;
	int __oldJump;
	struct Multi_String __oldMFString;
	struct Uni_String *__oldSFString;
	double bindTime;
	struct Uni_String *description;
	float fieldOfView;
	void *geoOrigin;
	struct Multi_String geoSystem;
	int headlight;
	int isBound;
	int jump;
	void *metadata;
	struct Multi_String navType;
	struct SFRotation orientation;
	struct SFVec3d position;
	int set_bind;
	struct SFRotation set_orientation;
	struct SFVec3d set_position;
	float speedFactor;
};
extern struct X3D_Virt virt_GeoViewpoint;
/***********************/
struct X3D_Group {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node FreeWRL_PROTOInterfaceNodes;
	int FreeWRL__protoDef;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	void *metadata;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_Group;
/***********************/
struct X3D_HAnimDisplacer {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 coordIndex;
	struct Multi_Vec3f displacements;
	void *metadata;
	struct Uni_String *name;
	float weight;
};
extern struct X3D_Virt virt_HAnimDisplacer;
/***********************/
struct X3D_HAnimHumanoid {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_String info;
	struct Multi_Node joints;
	void *metadata;
	struct Uni_String *name;
	struct SFRotation rotation;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	struct Multi_Node segments;
	struct Multi_Node sites;
	struct Multi_Node skeleton;
	struct Multi_Node skin;
	void *skinCoord;
	void *skinNormal;
	struct SFColor translation;
	struct Uni_String *version;
	struct Multi_Node viewpoints;
};
extern struct X3D_Virt virt_HAnimHumanoid;
/***********************/
struct X3D_HAnimJoint {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __do_center;
	int __do_rotation;
	int __do_scale;
	int __do_scaleO;
	int __do_trans;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_Node children;
	struct Multi_Node displacers;
	struct SFRotation limitOrientation;
	struct Multi_Float llimit;
	void *metadata;
	struct Uni_String *name;
	struct Multi_Node removeChildren;
	struct SFRotation rotation;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	struct Multi_Int32 skinCoordIndex;
	struct Multi_Float skinCoordWeight;
	struct Multi_Float stiffness;
	struct SFColor translation;
	struct Multi_Float ulimit;
};
extern struct X3D_Virt virt_HAnimJoint;
/***********************/
struct X3D_HAnimSegment {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor centerOfMass;
	struct Multi_Node children;
	void *coord;
	struct Multi_Node displacers;
	float mass;
	void *metadata;
	struct Multi_Float momentsOfInertia;
	struct Uni_String *name;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_HAnimSegment;
/***********************/
struct X3D_HAnimSite {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __do_center;
	int __do_rotation;
	int __do_scale;
	int __do_scaleO;
	int __do_trans;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_Node children;
	void *metadata;
	struct Uni_String *name;
	struct Multi_Node removeChildren;
	struct SFRotation rotation;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	struct SFColor translation;
};
extern struct X3D_Virt virt_HAnimSite;
/***********************/
struct X3D_ImageCubeMapTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __regenSubTextures;
	struct Multi_Node __subTextures;
	int __textureTableIndex;
	void * _parentResource;
	void *metadata;
	void *textureProperties;
	struct Multi_String url;
};
extern struct X3D_Virt virt_ImageCubeMapTexture;
/***********************/
struct X3D_ImageTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __textureTableIndex;
	void * _parentResource;
	void *metadata;
	int repeatS;
	int repeatT;
	void *textureProperties;
	struct Multi_String url;
};
extern struct X3D_Virt virt_ImageTexture;
/***********************/
struct X3D_IndexedFaceSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	int ccw;
	void *color;
	struct Multi_Int32 colorIndex;
	int colorPerVertex;
	int convex;
	void *coord;
	struct Multi_Int32 coordIndex;
	float creaseAngle;
	void *fogCoord;
	void *metadata;
	void *normal;
	struct Multi_Int32 normalIndex;
	int normalPerVertex;
	struct Multi_Int32 set_colorIndex;
	struct Multi_Int32 set_coordIndex;
	struct Multi_Int32 set_normalIndex;
	struct Multi_Int32 set_texCoordIndex;
	int solid;
	void *texCoord;
	struct Multi_Int32 texCoordIndex;
};
extern struct X3D_Virt virt_IndexedFaceSet;
/***********************/
struct X3D_IndexedLineSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __colours;
	int __segCount;
	void * __vertArr;
	void * __vertIndx;
	void * __vertexCount;
	void * __vertices;
	struct Multi_Node attrib;
	void *color;
	struct Multi_Int32 colorIndex;
	int colorPerVertex;
	void *coord;
	struct Multi_Int32 coordIndex;
	void *fogCoord;
	void *metadata;
	struct Multi_Int32 set_colorIndex;
	struct Multi_Int32 set_coordIndex;
};
extern struct X3D_Virt virt_IndexedLineSet;
/***********************/
struct X3D_IndexedTriangleFanSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	void *fogCoord;
	struct Multi_Int32 index;
	void *metadata;
	void *normal;
	int normalPerVertex;
	struct Multi_Int32 set_index;
	int solid;
	void *texCoord;
};
extern struct X3D_Virt virt_IndexedTriangleFanSet;
/***********************/
struct X3D_IndexedTriangleSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	void *fogCoord;
	struct Multi_Int32 index;
	void *metadata;
	void *normal;
	int normalPerVertex;
	struct Multi_Int32 set_index;
	int solid;
	void *texCoord;
};
extern struct X3D_Virt virt_IndexedTriangleSet;
/***********************/
struct X3D_IndexedTriangleStripSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	void *fogCoord;
	struct Multi_Int32 index;
	void *metadata;
	void *normal;
	int normalPerVertex;
	struct Multi_Int32 set_index;
	int solid;
	void *texCoord;
};
extern struct X3D_Virt virt_IndexedTriangleStripSet;
/***********************/
struct X3D_Inline {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node __children;
	void * __loadResource;
	int __loadstatus;
	void * _parentResource;
	struct Multi_Node _sortedChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	int load;
	void *metadata;
	struct Multi_String url;
};
extern struct X3D_Virt virt_Inline;
/***********************/
struct X3D_IntegerSequencer {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Int32 keyValue;
	void *metadata;
	int next;
	int previous;
	float set_fraction;
	int value_changed;
};
extern struct X3D_Virt virt_IntegerSequencer;
/***********************/
struct X3D_IntegerTrigger {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int integerKey;
	void *metadata;
	double set_triggerTime;
	int triggerValue;
};
extern struct X3D_Virt virt_IntegerTrigger;
/***********************/
struct X3D_KeySensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	int actionKeyPress;
	int actionKeyRelease;
	int altKey;
	int controlKey;
	int enabled;
	int isActive;
	struct Uni_String *keyPress;
	struct Uni_String *keyRelease;
	void *metadata;
	int shiftKey;
};
extern struct X3D_Virt virt_KeySensor;
/***********************/
struct X3D_LOD {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __isX3D;
	void * _selected;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_Node children;
	int forceTransitions;
	struct Multi_Node level;
	int levelChanged;
	void *metadata;
	struct Multi_Float range;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_LOD;
/***********************/
struct X3D_LineProperties {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int applied;
	int linetype;
	float linewidthScaleFactor;
	void *metadata;
};
extern struct X3D_Virt virt_LineProperties;
/***********************/
struct X3D_LineSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __segCount;
	void * __vertArr;
	void * __vertIndx;
	struct Multi_Node attrib;
	void *color;
	void *coord;
	void *fogCoord;
	void *metadata;
	struct Multi_Int32 vertexCount;
};
extern struct X3D_Virt virt_LineSet;
/***********************/
struct X3D_LoadSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double __StartLoadTime;
	int __finishedloading;
	int __loading;
	int __oldEnabled;
	int enabled;
	int isActive;
	int isLoaded;
	double loadTime;
	void *metadata;
	float progress;
	double timeOut;
	struct Multi_Node watchList;
};
extern struct X3D_Virt virt_LoadSensor;
/***********************/
struct X3D_LocalFog {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor color;
	int enabled;
	struct Uni_String *fogType;
	void *metadata;
	float visibilityRange;
};
extern struct X3D_Virt virt_LocalFog;
/***********************/
struct X3D_Material {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec4f _amb;
	struct SFVec4f _dcol;
	struct SFVec4f _ecol;
	struct SFVec4f _scol;
	float _shin;
	float ambientIntensity;
	struct SFColor diffuseColor;
	struct SFColor emissiveColor;
	void *metadata;
	float shininess;
	struct SFColor specularColor;
	float transparency;
};
extern struct X3D_Virt virt_Material;
/***********************/
struct X3D_Matrix3VertexAttribute {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Multi_Matrix3f value;
};
extern struct X3D_Virt virt_Matrix3VertexAttribute;
/***********************/
struct X3D_Matrix4VertexAttribute {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Multi_Matrix4f value;
};
extern struct X3D_Virt virt_Matrix4VertexAttribute;
/***********************/
struct X3D_MetadataDouble {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Double value;
};
extern struct X3D_Virt virt_MetadataDouble;
/***********************/
struct X3D_MetadataFloat {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Float value;
};
extern struct X3D_Virt virt_MetadataFloat;
/***********************/
struct X3D_MetadataInteger {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Int32 value;
};
extern struct X3D_Virt virt_MetadataInteger;
/***********************/
struct X3D_MetadataMFBool {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Bool setValue;
	double tickTime;
	struct Multi_Bool value;
	struct Multi_Bool valueChanged;
};
extern struct X3D_Virt virt_MetadataMFBool;
/***********************/
struct X3D_MetadataMFColor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Color setValue;
	double tickTime;
	struct Multi_Color value;
	struct Multi_Color valueChanged;
};
extern struct X3D_Virt virt_MetadataMFColor;
/***********************/
struct X3D_MetadataMFColorRGBA {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_ColorRGBA setValue;
	double tickTime;
	struct Multi_ColorRGBA value;
	struct Multi_ColorRGBA valueChanged;
};
extern struct X3D_Virt virt_MetadataMFColorRGBA;
/***********************/
struct X3D_MetadataMFDouble {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Double setValue;
	double tickTime;
	struct Multi_Double value;
	struct Multi_Double valueChanged;
};
extern struct X3D_Virt virt_MetadataMFDouble;
/***********************/
struct X3D_MetadataMFFloat {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float setValue;
	double tickTime;
	struct Multi_Float value;
	struct Multi_Float valueChanged;
};
extern struct X3D_Virt virt_MetadataMFFloat;
/***********************/
struct X3D_MetadataMFInt32 {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 setValue;
	double tickTime;
	struct Multi_Int32 value;
	struct Multi_Int32 valueChanged;
};
extern struct X3D_Virt virt_MetadataMFInt32;
/***********************/
struct X3D_MetadataMFMatrix3d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Matrix3d setValue;
	double tickTime;
	struct Multi_Matrix3d value;
	struct Multi_Matrix3d valueChanged;
};
extern struct X3D_Virt virt_MetadataMFMatrix3d;
/***********************/
struct X3D_MetadataMFMatrix3f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Matrix3f setValue;
	double tickTime;
	struct Multi_Matrix3f value;
	struct Multi_Matrix3f valueChanged;
};
extern struct X3D_Virt virt_MetadataMFMatrix3f;
/***********************/
struct X3D_MetadataMFMatrix4d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Matrix4d setValue;
	double tickTime;
	struct Multi_Matrix4d value;
	struct Multi_Matrix4d valueChanged;
};
extern struct X3D_Virt virt_MetadataMFMatrix4d;
/***********************/
struct X3D_MetadataMFMatrix4f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Matrix4f setValue;
	double tickTime;
	struct Multi_Matrix4f value;
	struct Multi_Matrix4f valueChanged;
};
extern struct X3D_Virt virt_MetadataMFMatrix4f;
/***********************/
struct X3D_MetadataMFNode {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node setValue;
	double tickTime;
	struct Multi_Node value;
	struct Multi_Node valueChanged;
};
extern struct X3D_Virt virt_MetadataMFNode;
/***********************/
struct X3D_MetadataMFRotation {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Rotation setValue;
	double tickTime;
	struct Multi_Rotation value;
	struct Multi_Rotation valueChanged;
};
extern struct X3D_Virt virt_MetadataMFRotation;
/***********************/
struct X3D_MetadataMFString {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_String setValue;
	double tickTime;
	struct Multi_String value;
	struct Multi_String valueChanged;
};
extern struct X3D_Virt virt_MetadataMFString;
/***********************/
struct X3D_MetadataMFTime {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Time setValue;
	double tickTime;
	struct Multi_Time value;
	struct Multi_Time valueChanged;
};
extern struct X3D_Virt virt_MetadataMFTime;
/***********************/
struct X3D_MetadataMFVec2d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2d setValue;
	double tickTime;
	struct Multi_Vec2d value;
	struct Multi_Vec2d valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec2d;
/***********************/
struct X3D_MetadataMFVec2f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2f setValue;
	double tickTime;
	struct Multi_Vec2f value;
	struct Multi_Vec2f valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec2f;
/***********************/
struct X3D_MetadataMFVec3d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec3d setValue;
	double tickTime;
	struct Multi_Vec3d value;
	struct Multi_Vec3d valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec3d;
/***********************/
struct X3D_MetadataMFVec3f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec3f setValue;
	double tickTime;
	struct Multi_Vec3f value;
	struct Multi_Vec3f valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec3f;
/***********************/
struct X3D_MetadataMFVec4d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec4d setValue;
	double tickTime;
	struct Multi_Vec4d value;
	struct Multi_Vec4d valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec4d;
/***********************/
struct X3D_MetadataMFVec4f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec4f setValue;
	double tickTime;
	struct Multi_Vec4f value;
	struct Multi_Vec4f valueChanged;
};
extern struct X3D_Virt virt_MetadataMFVec4f;
/***********************/
struct X3D_MetadataSFBool {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int setValue;
	double tickTime;
	int value;
	int valueChanged;
};
extern struct X3D_Virt virt_MetadataSFBool;
/***********************/
struct X3D_MetadataSFColor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor setValue;
	double tickTime;
	struct SFColor value;
	struct SFColor valueChanged;
};
extern struct X3D_Virt virt_MetadataSFColor;
/***********************/
struct X3D_MetadataSFColorRGBA {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColorRGBA setValue;
	double tickTime;
	struct SFColorRGBA value;
	struct SFColorRGBA valueChanged;
};
extern struct X3D_Virt virt_MetadataSFColorRGBA;
/***********************/
struct X3D_MetadataSFDouble {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double setValue;
	double tickTime;
	double value;
	double valueChanged;
};
extern struct X3D_Virt virt_MetadataSFDouble;
/***********************/
struct X3D_MetadataSFFloat {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float setValue;
	double tickTime;
	float value;
	float valueChanged;
};
extern struct X3D_Virt virt_MetadataSFFloat;
/***********************/
struct X3D_MetadataSFImage {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 setValue;
	double tickTime;
	struct Multi_Int32 value;
	struct Multi_Int32 valueChanged;
};
extern struct X3D_Virt virt_MetadataSFImage;
/***********************/
struct X3D_MetadataSFInt32 {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int setValue;
	double tickTime;
	int value;
	int valueChanged;
};
extern struct X3D_Virt virt_MetadataSFInt32;
/***********************/
struct X3D_MetadataSFMatrix3d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFMatrix3d setValue;
	double tickTime;
	struct SFMatrix3d value;
	struct SFMatrix3d valueChanged;
};
extern struct X3D_Virt virt_MetadataSFMatrix3d;
/***********************/
struct X3D_MetadataSFMatrix3f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFMatrix3f setValue;
	double tickTime;
	struct SFMatrix3f value;
	struct SFMatrix3f valueChanged;
};
extern struct X3D_Virt virt_MetadataSFMatrix3f;
/***********************/
struct X3D_MetadataSFMatrix4d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFMatrix4d setValue;
	double tickTime;
	struct SFMatrix4d value;
	struct SFMatrix4d valueChanged;
};
extern struct X3D_Virt virt_MetadataSFMatrix4d;
/***********************/
struct X3D_MetadataSFMatrix4f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFMatrix4f setValue;
	double tickTime;
	struct SFMatrix4f value;
	struct SFMatrix4f valueChanged;
};
extern struct X3D_Virt virt_MetadataSFMatrix4f;
/***********************/
struct X3D_MetadataSFNode {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *setValue;
	double tickTime;
	void *value;
	void *valueChanged;
};
extern struct X3D_Virt virt_MetadataSFNode;
/***********************/
struct X3D_MetadataSFRotation {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFRotation setValue;
	double tickTime;
	struct SFRotation value;
	struct SFRotation valueChanged;
};
extern struct X3D_Virt virt_MetadataSFRotation;
/***********************/
struct X3D_MetadataSFString {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *setValue;
	double tickTime;
	struct Uni_String *value;
	struct Uni_String *valueChanged;
};
extern struct X3D_Virt virt_MetadataSFString;
/***********************/
struct X3D_MetadataSFTime {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double setValue;
	double tickTime;
	double value;
	double valueChanged;
};
extern struct X3D_Virt virt_MetadataSFTime;
/***********************/
struct X3D_MetadataSFVec2d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec2d setValue;
	double tickTime;
	struct SFVec2d value;
	struct SFVec2d valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec2d;
/***********************/
struct X3D_MetadataSFVec2f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec2f setValue;
	double tickTime;
	struct SFVec2f value;
	struct SFVec2f valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec2f;
/***********************/
struct X3D_MetadataSFVec3d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec3d setValue;
	double tickTime;
	struct SFVec3d value;
	struct SFVec3d valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec3d;
/***********************/
struct X3D_MetadataSFVec3f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor setValue;
	double tickTime;
	struct SFColor value;
	struct SFColor valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec3f;
/***********************/
struct X3D_MetadataSFVec4d {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec4d setValue;
	double tickTime;
	struct SFVec4d value;
	struct SFVec4d valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec4d;
/***********************/
struct X3D_MetadataSFVec4f {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec4f setValue;
	double tickTime;
	struct SFVec4f value;
	struct SFVec4f valueChanged;
};
extern struct X3D_Virt virt_MetadataSFVec4f;
/***********************/
struct X3D_MetadataSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_Node value;
};
extern struct X3D_Virt virt_MetadataSet;
/***********************/
struct X3D_MetadataString {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Uni_String *name;
	struct Uni_String *reference;
	struct Multi_String value;
};
extern struct X3D_Virt virt_MetadataString;
/***********************/
struct X3D_MidiControl {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int _bus;
	int _butPr;
	int _channel;
	int _controller;
	int _controllerIndex;
	int _deviceNameIndex;
	int _intControllerType;
	int _oldintValue;
	int _sentVel;
	int _vel;
	int autoButtonPress;
	int buttonPress;
	int channel;
	struct Uni_String *controller;
	int controllerPresent;
	struct Uni_String *controllerType;
	int deviceMaxVal;
	int deviceMinVal;
	struct Uni_String *deviceName;
	float floatValue;
	int highResolution;
	int intValue;
	int maxVal;
	void *metadata;
	int minVal;
	float pressLength;
	double pressTime;
	int useIntValue;
	int velocity;
};
extern struct X3D_Virt virt_MidiControl;
/***********************/
struct X3D_MovieTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __textureTableIndex;
	void * _parentResource;
	struct Uni_String *description;
	double duration_changed;
	double elapsedTime;
	int isActive;
	double isPaused;
	int loop;
	void *metadata;
	double pauseTime;
	int repeatS;
	int repeatT;
	double resumeTime;
	float speed;
	double startTime;
	double stopTime;
	void *textureProperties;
	struct Multi_String url;
};
extern struct X3D_Virt virt_MovieTexture;
/***********************/
struct X3D_MultiTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __params;
	float alpha;
	struct SFColor color;
	struct Multi_String function;
	void *metadata;
	struct Multi_String mode;
	struct Multi_String source;
	struct Multi_Node texture;
};
extern struct X3D_Virt virt_MultiTexture;
/***********************/
struct X3D_MultiTextureCoordinate {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Multi_Node texCoord;
};
extern struct X3D_Virt virt_MultiTextureCoordinate;
/***********************/
struct X3D_MultiTextureTransform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Multi_Node textureTransform;
};
extern struct X3D_Virt virt_MultiTextureTransform;
/***********************/
struct X3D_NavigationInfo {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	struct Multi_Float avatarSize;
	double bindTime;
	int headlight;
	int isBound;
	void *metadata;
	int set_bind;
	float speed;
	int transitionComplete;
	double transitionTime;
	struct Multi_String transitionType;
	struct Multi_String type;
	float visibilityLimit;
};
extern struct X3D_Virt virt_NavigationInfo;
/***********************/
struct X3D_Normal {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Multi_Vec3f vector;
};
extern struct X3D_Virt virt_Normal;
/***********************/
struct X3D_NormalInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	void *metadata;
	float set_fraction;
	struct Multi_Vec3f value_changed;
};
extern struct X3D_Virt virt_NormalInterpolator;
/***********************/
struct X3D_NurbsCurve {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec3f controlPoint;
	struct Multi_Float knot;
	void *metadata;
	int order;
	int tessellation;
	struct Multi_Float weight;
};
extern struct X3D_Virt virt_NurbsCurve;
/***********************/
struct X3D_NurbsCurve2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2f controlPoint;
	struct Multi_Float knot;
	void *metadata;
	int order;
	int tessellation;
	struct Multi_Float weight;
};
extern struct X3D_Virt virt_NurbsCurve2D;
/***********************/
struct X3D_NurbsGroup {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	void *metadata;
	struct Multi_Node removeChildren;
	float tessellationScale;
};
extern struct X3D_Virt virt_NurbsGroup;
/***********************/
struct X3D_NurbsPositionInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int dimension;
	struct Multi_Vec3f keyValue;
	struct Multi_Float keyWeight;
	struct Multi_Float knot;
	void *metadata;
	int order;
	float set_fraction;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_NurbsPositionInterpolator;
/***********************/
struct X3D_NurbsSurface {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int ccw;
	struct Multi_Vec3f controlPoint;
	struct Multi_Float knot;
	void *metadata;
	int order;
	void *texCoord;
	int uTessellation;
	int vTessellation;
	struct Multi_Float weight;
};
extern struct X3D_Virt virt_NurbsSurface;
/***********************/
struct X3D_NurbsTextureSurface {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
};
extern struct X3D_Virt virt_NurbsTextureSurface;
/***********************/
struct X3D_NurbsTrimmedSurface {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
};
extern struct X3D_Virt virt_NurbsTrimmedSurface;
/***********************/
struct X3D_OrientationInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Rotation keyValue;
	void *metadata;
	float set_fraction;
	struct SFRotation value_changed;
};
extern struct X3D_Virt virt_OrientationInterpolator;
/***********************/
struct X3D_OrthoViewpoint {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	double bindTime;
	struct SFColor centerOfRotation;
	struct Uni_String *description;
	struct Multi_Float fieldOfView;
	int isBound;
	int jump;
	void *metadata;
	struct SFRotation orientation;
	struct SFColor position;
	int retainUserOffsets;
	int set_bind;
};
extern struct X3D_Virt virt_OrthoViewpoint;
/***********************/
struct X3D_PackagedShader {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __shaderObj;
	int activate;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	void *metadata;
	struct Multi_String url;
};
extern struct X3D_Virt virt_PackagedShader;
/***********************/
struct X3D_PickableGroup {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node FreeWRL_PROTOInterfaceNodes;
	int FreeWRL__protoDef;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	void *metadata;
	struct Multi_String objectType;
	int pickable;
	struct Multi_Node removeChildren;
};
extern struct X3D_Virt virt_PickableGroup;
/***********************/
struct X3D_PixelTexture {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __textureTableIndex;
	void * _parentResource;
	struct Multi_Int32 image;
	void *metadata;
	int repeatS;
	int repeatT;
	void *textureProperties;
};
extern struct X3D_Virt virt_PixelTexture;
/***********************/
struct X3D_PlaneSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	struct SFColor _oldtrackPoint;
	struct SFColor _oldtranslation;
	struct SFColor _origPoint;
	int autoOffset;
	struct Uni_String *description;
	int enabled;
	int isActive;
	int isOver;
	struct SFVec2f maxPosition;
	void *metadata;
	struct SFVec2f minPosition;
	struct SFColor offset;
	struct SFColor trackPoint_changed;
	struct SFColor translation_changed;
};
extern struct X3D_Virt virt_PlaneSensor;
/***********************/
struct X3D_PointLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFColor attenuation;
	struct SFColor color;
	int global;
	float intensity;
	struct SFColor location;
	void *metadata;
	int on;
	float radius;
};
extern struct X3D_Virt virt_PointLight;
/***********************/
struct X3D_PointPickSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor _bboxCenter;
	struct SFColor _bboxSize;
	int _oldisActive;
	struct Multi_Node _oldpickTarget;
	struct Multi_Node _oldpickedGeometry;
	struct Multi_Vec3f _oldpickedPoint;
	int enabled;
	struct Uni_String *intersectionType;
	int isActive;
	void *metadata;
	struct Multi_String objectType;
	struct Multi_Node pickTarget;
	struct Multi_Node pickedGeometry;
	struct Multi_Vec3f pickedPoint;
	void *pickingGeometry;
	struct Uni_String *set_intersectionType;
	struct Uni_String *set_sortOrder;
	struct Uni_String *sortOrder;
};
extern struct X3D_Virt virt_PointPickSensor;
/***********************/
struct X3D_PointSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node attrib;
	void *color;
	void *coord;
	void *fogCoord;
	void *metadata;
};
extern struct X3D_Virt virt_PointSet;
/***********************/
struct X3D_Polyline2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2f lineSegments;
	void *metadata;
};
extern struct X3D_Virt virt_Polyline2D;
/***********************/
struct X3D_Polypoint2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_Polypoint2D;
/***********************/
struct X3D_PositionInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	void *metadata;
	float set_fraction;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_PositionInterpolator;
/***********************/
struct X3D_PositionInterpolator2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	void *metadata;
	float set_fraction;
	struct SFVec2f value_changed;
};
extern struct X3D_Virt virt_PositionInterpolator2D;
/***********************/
struct X3D_ProgramShader {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __initialized;
	struct Multi_Int32 __shaderIDS;
	int activate;
	int isSelected;
	int isValid;
	struct Uni_String *language;
	void *metadata;
	struct Multi_Node programs;
};
extern struct X3D_Virt virt_ProgramShader;
/***********************/
struct X3D_ProximitySensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __hit;
	int __oldEnabled;
	struct SFColor __t1;
	struct SFRotation __t2;
	struct SFColor center;
	struct SFColor centerOfRotation_changed;
	int enabled;
	double enterTime;
	double exitTime;
	int isActive;
	void *metadata;
	struct SFRotation orientation_changed;
	struct SFColor position_changed;
	struct SFColor size;
};
extern struct X3D_Virt virt_ProximitySensor;
/***********************/
struct X3D_ReceiverPdu {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *address;
	int applicationID;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	int enabled;
	int entityID;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	void *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	int radioID;
	float readInterval;
	float receivedPower;
	int receiverState;
	int rtpHeaderExpected;
	int siteID;
	double timestamp;
	int transmitterApplicationID;
	int transmitterEntityID;
	int transmitterRadioID;
	int transmitterSiteID;
	int whichGeometry;
	float writeInterval;
};
extern struct X3D_Virt virt_ReceiverPdu;
/***********************/
struct X3D_Rectangle2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __numPoints;
	void * __points;
	void *metadata;
	struct SFVec2f size;
	int solid;
};
extern struct X3D_Virt virt_Rectangle2D;
/***********************/
struct X3D_ScalarInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Float keyValue;
	void *metadata;
	float set_fraction;
	float value_changed;
};
extern struct X3D_Virt virt_ScalarInterpolator;
/***********************/
struct X3D_Script {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __scriptObj;
	void * _parentResource;
	int directOutput;
	void *metadata;
	int mustEvaluate;
	struct Multi_String url;
};
extern struct X3D_Virt virt_Script;
/***********************/
struct X3D_ShaderPart {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * _parentResource;
	void *metadata;
	struct Uni_String *type;
	struct Multi_String url;
};
extern struct X3D_Virt virt_ShaderPart;
/***********************/
struct X3D_ShaderProgram {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __shaderObj;
	void * _parentResource;
	void *metadata;
	struct Uni_String *type;
	struct Multi_String url;
};
extern struct X3D_Virt virt_ShaderProgram;
/***********************/
struct X3D_Shape {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __Samples;
	int __occludeCheckCount;
	int __visible;
	void *appearance;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	void *geometry;
	void *metadata;
};
extern struct X3D_Virt virt_Shape;
/***********************/
struct X3D_SignalPdu {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *address;
	int applicationID;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Int32 data;
	int dataLength;
	int enabled;
	int encodingScheme;
	int entityID;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	void *metadata;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	int radioID;
	float readInterval;
	int rtpHeaderExpected;
	int sampleRate;
	int samples;
	int siteID;
	int tdlType;
	double timestamp;
	int whichGeometry;
	float writeInterval;
};
extern struct X3D_Virt virt_SignalPdu;
/***********************/
struct X3D_Sound {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor direction;
	float intensity;
	struct SFColor location;
	float maxBack;
	float maxFront;
	void *metadata;
	float minBack;
	float minFront;
	float priority;
	void *source;
	int spatialize;
};
extern struct X3D_Virt virt_Sound;
/***********************/
struct X3D_Sphere {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __points;
	int _sideVBO;
	void *metadata;
	float radius;
	int solid;
};
extern struct X3D_Virt virt_Sphere;
/***********************/
struct X3D_SphereSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	struct SFRotation _oldrotation;
	struct SFColor _oldtrackPoint;
	struct SFColor _origNormalizedPoint;
	struct SFColor _origPoint;
	float _radius;
	int autoOffset;
	struct Uni_String *description;
	int enabled;
	int isActive;
	int isOver;
	void *metadata;
	struct SFRotation offset;
	struct SFRotation rotation_changed;
	struct SFColor trackPoint_changed;
};
extern struct X3D_Virt virt_SphereSensor;
/***********************/
struct X3D_SplinePositionInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int closed;
	struct Multi_Float key;
	struct Multi_Vec3f keyValue;
	struct Multi_Vec3f keyVelocity;
	void *metadata;
	int normalizeVelocity;
	float set_fraction;
	struct SFColor value_changed;
};
extern struct X3D_Virt virt_SplinePositionInterpolator;
/***********************/
struct X3D_SplinePositionInterpolator2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int closed;
	struct Multi_Float key;
	struct Multi_Vec2f keyValue;
	struct Multi_Vec2f keyVelocity;
	void *metadata;
	int normalizeVelocity;
	float set_fraction;
	struct SFVec2f value_changed;
};
extern struct X3D_Virt virt_SplinePositionInterpolator2D;
/***********************/
struct X3D_SplineScalarInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int closed;
	struct Multi_Float key;
	struct Multi_Float keyValue;
	struct Multi_Float keyVelocity;
	void *metadata;
	int normalizeVelocity;
	float set_fraction;
	float value_changed;
};
extern struct X3D_Virt virt_SplineScalarInterpolator;
/***********************/
struct X3D_SpotLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float ambientIntensity;
	struct SFColor attenuation;
	float beamWidth;
	struct SFColor color;
	float cutOffAngle;
	struct SFColor direction;
	int global;
	float intensity;
	struct SFColor location;
	void *metadata;
	int on;
	float radius;
};
extern struct X3D_Virt virt_SpotLight;
/***********************/
struct X3D_SquadOrientationInterpolator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Float key;
	struct Multi_Rotation keyValue;
	void *metadata;
	int normalizeVelocity;
	float set_fraction;
	struct SFRotation value_changed;
};
extern struct X3D_Virt virt_SquadOrientationInterpolator;
/***********************/
struct X3D_StaticGroup {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __solid;
	int __transparency;
	struct Multi_Node _sortedChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	void *metadata;
};
extern struct X3D_Virt virt_StaticGroup;
/***********************/
struct X3D_StringSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	int _initialized;
	int deletionAllowed;
	int enabled;
	struct Uni_String *enteredText;
	struct Uni_String *finalText;
	int isActive;
	void *metadata;
};
extern struct X3D_Virt virt_StringSensor;
/***********************/
struct X3D_Switch {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __isX3D;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Multi_Node children;
	struct Multi_Node choice;
	void *metadata;
	struct Multi_Node removeChildren;
	int whichChoice;
};
extern struct X3D_Virt virt_Switch;
/***********************/
struct X3D_Text {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __rendersub;
	void *fontStyle;
	struct Multi_Float length;
	struct Multi_Vec2f lineBounds;
	float maxExtent;
	void *metadata;
	struct SFColor origin;
	int solid;
	struct Multi_String string;
	struct SFVec2f textBounds;
};
extern struct X3D_Virt virt_Text;
/***********************/
struct X3D_TextureBackground {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	void * __colours;
	void * __points;
	int __quadcount;
	void * _parentResource;
	void *backTexture;
	double bindTime;
	void *bottomTexture;
	void *frontTexture;
	struct Multi_Float groundAngle;
	struct Multi_Color groundColor;
	int isBound;
	void *leftTexture;
	void *metadata;
	void *rightTexture;
	int set_bind;
	struct Multi_Float skyAngle;
	struct Multi_Color skyColor;
	void *topTexture;
	struct Multi_Float transparency;
};
extern struct X3D_Virt virt_TextureBackground;
/***********************/
struct X3D_TextureCoordinate {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __VBO;
	struct Multi_Vec2f __compiledpoint;
	void * __lastParent;
	void *metadata;
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_TextureCoordinate;
/***********************/
struct X3D_TextureCoordinateGenerator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __compiledmode;
	void *metadata;
	struct Uni_String *mode;
	struct Multi_Float parameter;
};
extern struct X3D_Virt virt_TextureCoordinateGenerator;
/***********************/
struct X3D_TextureProperties {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float anisotropicDegree;
	struct SFColorRGBA borderColor;
	int borderWidth;
	struct Uni_String *boundaryModeR;
	struct Uni_String *boundaryModeS;
	struct Uni_String *boundaryModeT;
	int generateMipMaps;
	struct Uni_String *magnificationFilter;
	void *metadata;
	struct Uni_String *minificationFilter;
	struct Uni_String *textureCompression;
	float texturePriority;
};
extern struct X3D_Virt virt_TextureProperties;
/***********************/
struct X3D_TextureTransform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec2f center;
	void *metadata;
	float rotation;
	struct SFVec2f scale;
	struct SFVec2f translation;
};
extern struct X3D_Virt virt_TextureTransform;
/***********************/
struct X3D_TimeSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	double __ctflag;
	double __inittime;
	int __oldEnabled;
	double cycleInterval;
	double cycleTime;
	double elapsedTime;
	int enabled;
	float fraction_changed;
	int isActive;
	double isPaused;
	int loop;
	void *metadata;
	double pauseTime;
	double resumeTime;
	double startTime;
	double stopTime;
	double time;
};
extern struct X3D_Virt virt_TimeSensor;
/***********************/
struct X3D_TimeTrigger {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *metadata;
	int set_boolean;
	double triggerTime;
};
extern struct X3D_Virt virt_TimeTrigger;
/***********************/
struct X3D_TouchSensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __oldEnabled;
	struct SFColor _oldhitNormal;
	struct SFColor _oldhitPoint;
	struct SFVec2f _oldhitTexCoord;
	struct Uni_String *description;
	int enabled;
	struct SFColor hitNormal_changed;
	struct SFColor hitPoint_changed;
	struct SFVec2f hitTexCoord_changed;
	int isActive;
	int isOver;
	void *metadata;
	double touchTime;
};
extern struct X3D_Virt virt_TouchSensor;
/***********************/
struct X3D_Transform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __do_anything;
	int __do_center;
	int __do_rotation;
	int __do_scale;
	int __do_scaleO;
	int __do_trans;
	struct Multi_Node _sortedChildren;
	struct Multi_Node addChildren;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct SFColor center;
	struct Multi_Node children;
	void *metadata;
	struct Multi_Node removeChildren;
	struct SFRotation rotation;
	struct SFColor scale;
	struct SFRotation scaleOrientation;
	struct SFColor translation;
};
extern struct X3D_Virt virt_Transform;
/***********************/
struct X3D_TransmitterPdu {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *address;
	struct SFColor antennaLocation;
	int antennaPatternLength;
	int antennaPatternType;
	int applicationID;
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	int cryptoKeyID;
	int cryptoSystem;
	int enabled;
	int entityID;
	int frequency;
	int inputSource;
	int isActive;
	int isNetworkReader;
	int isNetworkWriter;
	int isRtpHeaderHeard;
	int isStandAlone;
	int lengthOfModulationParameters;
	void *metadata;
	int modulationTypeDetail;
	int modulationTypeMajor;
	int modulationTypeSpreadSpectrum;
	int modulationTypeSystem;
	struct Uni_String *multicastRelayHost;
	int multicastRelayPort;
	struct Uni_String *networkMode;
	int port;
	float power;
	int radioEntityTypeCategory;
	int radioEntityTypeCountry;
	int radioEntityTypeDomain;
	int radioEntityTypeKind;
	int radioEntityTypeNomenclature;
	int radioEntityTypeNomenclatureVersion;
	int radioID;
	float readInterval;
	struct SFColor relativeAntennaLocation;
	int rtpHeaderExpected;
	int siteID;
	double timestamp;
	float transmitFrequencyBandwidth;
	int transmitState;
	int whichGeometry;
	float writeInterval;
};
extern struct X3D_Virt virt_TransmitterPdu;
/***********************/
struct X3D_TriangleFanSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	struct Multi_Int32 fanCount;
	void *fogCoord;
	void *metadata;
	void *normal;
	int normalPerVertex;
	int solid;
	void *texCoord;
};
extern struct X3D_Virt virt_TriangleFanSet;
/***********************/
struct X3D_TriangleSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	void *fogCoord;
	void *metadata;
	void *normal;
	int normalPerVertex;
	int solid;
	void *texCoord;
};
extern struct X3D_Virt virt_TriangleSet;
/***********************/
struct X3D_TriangleSet2D {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void * __texCoords;
	void *metadata;
	int solid;
	struct Multi_Vec2f vertices;
};
extern struct X3D_Virt virt_TriangleSet2D;
/***********************/
struct X3D_TriangleStripSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Int32 _coordIndex;
	struct Multi_Node attrib;
	int ccw;
	void *color;
	int colorPerVertex;
	void *coord;
	void *fogCoord;
	void *metadata;
	void *normal;
	int normalPerVertex;
	int solid;
	struct Multi_Int32 stripCount;
	void *texCoord;
};
extern struct X3D_Virt virt_TriangleStripSet;
/***********************/
struct X3D_TwoSidedMaterial {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float ambientIntensity;
	float backAmbientIntensity;
	struct SFColor backDiffuseColor;
	struct SFColor backEmissiveColor;
	float backShininess;
	struct SFColor backSpecularColor;
	float backTransparency;
	struct SFColor diffuseColor;
	struct SFColor emissiveColor;
	void *metadata;
	int separateBackColor;
	float shininess;
	struct SFColor specularColor;
	float transparency;
};
extern struct X3D_Virt virt_TwoSidedMaterial;
/***********************/
struct X3D_VRML1_AsciiText {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	struct Uni_String *justification;
	float spacing;
	struct Multi_String string;
	struct Multi_Float width;
};
extern struct X3D_Virt virt_VRML1_AsciiText;
/***********************/
struct X3D_VRML1_Cone {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	float bottomRadius;
	float height;
	struct Uni_String *parts;
};
extern struct X3D_Virt virt_VRML1_Cone;
/***********************/
struct X3D_VRML1_Coordinate3 {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec3f point;
};
extern struct X3D_Virt virt_VRML1_Coordinate3;
/***********************/
struct X3D_VRML1_Cube {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	float depth;
	float height;
	float width;
};
extern struct X3D_Virt virt_VRML1_Cube;
/***********************/
struct X3D_VRML1_Cylinder {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	float height;
	struct Uni_String *parts;
	float radius;
};
extern struct X3D_Virt virt_VRML1_Cylinder;
/***********************/
struct X3D_VRML1_DirectionalLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor color;
	struct SFColor direction;
	float intensity;
	int on;
};
extern struct X3D_Virt virt_VRML1_DirectionalLight;
/***********************/
struct X3D_VRML1_FontStyle {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *family;
	float size;
	struct Uni_String *style;
};
extern struct X3D_Virt virt_VRML1_FontStyle;
/***********************/
struct X3D_VRML1_IndexedFaceSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int _ccw;
	void *_color;
	int _convex;
	void *_coord;
	int _cpv;
	float _creaseAngle;
	void *_normal;
	int _npv;
	int _solid;
	void *_texCoord;
	struct Multi_Int32 coordIndex;
	struct Multi_Int32 materialIndex;
	struct Multi_Int32 normalIndex;
	struct Multi_Int32 textureCoordIndex;
};
extern struct X3D_Virt virt_VRML1_IndexedFaceSet;
/***********************/
struct X3D_VRML1_IndexedLineSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	struct Multi_Int32 coordIndex;
	struct Multi_Int32 materialIndex;
	struct Multi_Int32 normalIndex;
	struct Multi_Int32 textureCoordIndex;
};
extern struct X3D_Virt virt_VRML1_IndexedLineSet;
/***********************/
struct X3D_VRML1_Info {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *string;
};
extern struct X3D_Virt virt_VRML1_Info;
/***********************/
struct X3D_VRML1_LOD {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor center;
	struct Multi_Float range;
};
extern struct X3D_Virt virt_VRML1_LOD;
/***********************/
struct X3D_VRML1_Material {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Color ambientColor;
	struct Multi_Color diffuseColor;
	struct Multi_Color emissiveColor;
	struct Multi_Float shininess;
	struct Multi_Color specularColor;
	struct Multi_Float transparency;
};
extern struct X3D_Virt virt_VRML1_Material;
/***********************/
struct X3D_VRML1_MaterialBinding {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int _Value;
	int _initialized;
	struct Uni_String *value;
};
extern struct X3D_Virt virt_VRML1_MaterialBinding;
/***********************/
struct X3D_VRML1_MatrixTransform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFMatrix4f value;
};
extern struct X3D_Virt virt_VRML1_MatrixTransform;
/***********************/
struct X3D_VRML1_Normal {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec3f vector;
};
extern struct X3D_Virt virt_VRML1_Normal;
/***********************/
struct X3D_VRML1_NormalBinding {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int _Value;
	int _initialized;
	struct Uni_String *value;
};
extern struct X3D_Virt virt_VRML1_NormalBinding;
/***********************/
struct X3D_VRML1_OrthographicCamera {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float focalDistance;
	float height;
	struct SFRotation orientation;
	struct SFColor position;
};
extern struct X3D_Virt virt_VRML1_OrthographicCamera;
/***********************/
struct X3D_VRML1_PerspectiveCamera {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	float focalDistance;
	float heightAngle;
	struct SFRotation orientation;
	struct SFColor position;
};
extern struct X3D_Virt virt_VRML1_PerspectiveCamera;
/***********************/
struct X3D_VRML1_PointLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor color;
	float intensity;
	struct SFColor location;
	int on;
};
extern struct X3D_Virt virt_VRML1_PointLight;
/***********************/
struct X3D_VRML1_PointSet {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int numPoints;
	int startIndex;
};
extern struct X3D_Virt virt_VRML1_PointSet;
/***********************/
struct X3D_VRML1_Rotation {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFRotation rotation;
};
extern struct X3D_Virt virt_VRML1_Rotation;
/***********************/
struct X3D_VRML1_Scale {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor scaleFactor;
};
extern struct X3D_Virt virt_VRML1_Scale;
/***********************/
struct X3D_VRML1_Separator {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Node VRML1children;
	struct Multi_Node _sortedChildren;
	struct Uni_String *renderCulling;
};
extern struct X3D_Virt virt_VRML1_Separator;
/***********************/
struct X3D_VRML1_ShapeHints {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int _faceValue;
	int _initialized;
	int _typeValue;
	int _vertValue;
	double creaseAngle;
	struct Uni_String *faceType;
	struct Uni_String *shapeType;
	struct Uni_String *vertexOrdering;
};
extern struct X3D_Virt virt_VRML1_ShapeHints;
/***********************/
struct X3D_VRML1_Sphere {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *_ILS;
	float radius;
};
extern struct X3D_Virt virt_VRML1_Sphere;
/***********************/
struct X3D_VRML1_SpotLight {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor color;
	float cutOffAngle;
	struct SFColor direction;
	float dropOffRate;
	float intensity;
	struct SFColor location;
	int on;
};
extern struct X3D_Virt virt_VRML1_SpotLight;
/***********************/
struct X3D_VRML1_Switch {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int whichChild;
};
extern struct X3D_Virt virt_VRML1_Switch;
/***********************/
struct X3D_VRML1_Texture2 {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __textureTableIndex;
	int _initialized;
	void * _parentResource;
	int _wrapS;
	int _wrapT;
	struct Multi_String filename;
	struct Multi_Int32 image;
	struct Uni_String *wrapS;
	struct Uni_String *wrapT;
};
extern struct X3D_Virt virt_VRML1_Texture2;
/***********************/
struct X3D_VRML1_Texture2Transform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFVec2f center;
	float rotation;
	struct SFVec2f scaleFactor;
	struct SFVec2f translation;
};
extern struct X3D_Virt virt_VRML1_Texture2Transform;
/***********************/
struct X3D_VRML1_TextureCoordinate2 {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_Vec2f point;
};
extern struct X3D_Virt virt_VRML1_TextureCoordinate2;
/***********************/
struct X3D_VRML1_Transform {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor center;
	struct SFRotation rotation;
	struct SFColor scaleFactor;
	struct SFRotation scaleOrientation;
	struct SFColor translation;
};
extern struct X3D_Virt virt_VRML1_Transform;
/***********************/
struct X3D_VRML1_Translation {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor translation;
};
extern struct X3D_Virt virt_VRML1_Translation;
/***********************/
struct X3D_VRML1_WWWAnchor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Uni_String *description;
	struct Uni_String *map;
	struct Uni_String *name;
};
extern struct X3D_Virt virt_VRML1_WWWAnchor;
/***********************/
struct X3D_VRML1_WWWInline {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct SFColor bboxCenter;
	struct SFColor bboxSize;
	struct Uni_String *name;
};
extern struct X3D_Virt virt_VRML1_WWWInline;
/***********************/
struct X3D_Viewpoint {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __BGNumber;
	double bindTime;
	struct SFColor centerOfRotation;
	struct Uni_String *description;
	float fieldOfView;
	int isBound;
	int jump;
	void *metadata;
	struct SFRotation orientation;
	struct SFColor position;
	int retainUserOffsets;
	int set_bind;
};
extern struct X3D_Virt virt_Viewpoint;
/***********************/
struct X3D_ViewpointGroup {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	void *__proxNode;
	struct SFColor center;
	struct Multi_Node children;
	struct Uni_String *description;
	int displayed;
	void *metadata;
	int retainUserOffsets;
	struct SFColor size;
};
extern struct X3D_Virt virt_ViewpointGroup;
/***********************/
struct X3D_VisibilitySensor {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	int __Samples;
	int __occludeCheckCount;
	int __oldEnabled;
	void * __points;
	int __visible;
	struct SFColor center;
	int enabled;
	double enterTime;
	double exitTime;
	int isActive;
	void *metadata;
	struct SFColor size;
};
extern struct X3D_Virt virt_VisibilitySensor;
/***********************/
struct X3D_WorldInfo {
       int _renderFlags; /*sensitive, etc */ 
       int _hit; 
       int _change; 
       void **_parents; 
       int _nparents; 
       int _nparalloc; 
       int _ichange; 
       double _dist; /*sorting for blending */ 
       float _extent[6]; /* used for boundingboxes - +-x, +-y, +-z */ 
       void *_intern; 
       int _nodeType; /* unique integer for each type */ 
       int referenceCount; /* if this reaches zero, nobody wants it anymore */ 
       int _defaultContainer; /* holds the container */
 	/*** node specific data: *****/
	struct Multi_String info;
	void *metadata;
	struct Uni_String *title;
};
extern struct X3D_Virt virt_WorldInfo;
extern struct X3D_Virt* virtTable[];

extern const int *NODE_OFFSETS[];

int getSAI_X3DNodeType (int FreeWRLNodeType);

#endif /* __FREEWRL_STRUCTS_H__ */
